/*****THIS FILE HANDLES THE CAMERA MOVEMENT,ZOOMING AND MOUSE CONTROLS*******/

//---------------------------------------------------------------------------------
//for testing free look 
var free_look = 0;

//speed of camera movement
var camera_speed = 200;

//zooming speed of the camera
var zoom_speed = 160;

//camera rotation	 speed
var rotate_strength = 12;

//selects whether to free look with mouse OR make it scroll in screen
//0 = free look
//1 = move/select 
var mouse_strafe = 0;

//pointer for the satellite entity
entity* SAT;

//the AMBIENT value of the CAMERA for temporaray storage
var cam_ambience;

//to store the satellite position and angles temporarily
var sat_position;

//sound handle for stopping zoom sound
var zoom_handle;

//the bounding x and y values of the satellite movement in a RTS level
//must be set before loading the RTS level
var min_level_x;
var max_level_x;
var min_level_y;
var max_level_y;

//the max and min zoom height of the satellite
//must be set before loading the RTS level
var max_zoom_height;
var min_zoom_height;

//this is the initial tilt of satellite and can be changed before loading levels
var sat_tilt = 14;

//------------------


//---------------------------------------------------------------------------------
//this is the main satellite or the camera control
//must be attatched to an entity
ACTION satellite_cam
{
//set satellite pointer
SAT = me;

//set max zoom height as my own z value given in WED
max_zoom_height = my.Z;

//set invisible so that no parts of camera entity are seen 
my.INVISIBLE = ON;

//set passable to avoid rockets and other entities
my.PASSABLE = ON;

//set the camera entity as genius
CAMERA.GENIUS = me;

//now set the CAMERA with me always
set_cam();

//set direction of motion for cursor keys
set_dir_for_cam();

//set tilt value
my.TILT = -sat_tilt;

//let the mouse rotate the camera
mouse_rotate();
}
//-------------------


//---------------------------------------------------------------------------------
var cam_temp_ang;

// as the name suggests
ACTION zoom_in {
IF(key_x==1) {RETURN;}
//PLAY_LOOP zoom_sound,60;
zoom_handle = RESULT;
        WHILE(key_z)
        {
         temp.X = zoom_speed;
         IF(KEY_SHIFT) {temp.X *= 1.5;}//boost the zoom speed
         temp.Y = 0;
         temp.Z = 0;
         cam_temp_ang.PAN = CAMERA.PAN;
         cam_temp_ang.TILT = 320;
         VECROTATE temp,cam_temp_ang;            
         MOVE SAT,NULLSKILL,temp;
         block_on_boundary();
         SAT.TILT = (sat_tilt*(SAT.Z - min_zoom_height))/(min_zoom_height - max_zoom_height);
         WAIT 1;
        }
//STOP_SOUND zoom_handle;
}
//--------------------------------


//---------------------------------------------------------------------------------
// as the name suggests
ACTION zoom_out {
IF(key_z==1) {RETURN;}
//PLAY_LOOP zoom_sound,60;
//zoom_handle = RESULT;
WHILE(key_x)	
        {
         temp.X = zoom_speed;
         IF(KEY_SHIFT) {temp.X *= 1.5;}//boost the zoom speed
         temp.Y = 0;
         temp.Z = 0;
         cam_temp_ang.PAN = CAMERA.PAN;
         cam_temp_ang.TILT = 140;
         VECROTATE temp,cam_temp_ang;            
         IF(SAT.Z<=max_zoom_height-20) { MOVE SAT,NULLSKILL,temp;}
         block_on_boundary();
         SAT.TILT = (sat_tilt*(SAT.Z - min_zoom_height))/(min_zoom_height - max_zoom_height);
         WAIT 1;         
        }   
//STOP_SOUND zoom_handle;
}
//--------------------------------



//---------------------------------------------------------------------------------
function scroll_up()
{
WHILE(mouse_strafe && rts)
 {
  IF(MOUSE_POS.Y<=2&&!MOUSE_LEFT) 
  {
  set_dir_for_cam();
  temp.x = SAT.SKILL2;
  temp.y = SAT.SKILL3;
  temp.z = SAT.SKILL4;
  vec_scale(temp,TIME);
  //IF(KEY_SHIFT==1) { vec_scale(temp,2); }
  //IF(KEY_Q==1) { vec_scale(temp,0.1); }
  MOVE SAT,NULLSKILL,SAT.SKILL2;
  block_on_boundary();
  }
 WAIT 1;
 }
}
//-------------------------------- 


//---------------------------------------------------------------------------------
function scroll_down()
{
WHILE(mouse_strafe && rts)
 {
  IF(MOUSE_POS.Y>=SCREEN_SIZE.Y-2&&!MOUSE_LEFT) 
  {
  set_dir_for_cam();
  temp.x = SAT.SKILL5;
  temp.y = SAT.SKILL6;
  temp.z = SAT.SKILL7;
  vec_scale(temp,TIME);
  IF(KEY_SHIFT==1) { vec_scale(temp,2); } 
  IF(KEY_Q==1) { vec_scale(temp,0.1); }
  MOVE SAT,NULLSKILL,SAT.SKILL5;
  block_on_boundary();
  }
 WAIT 1;
 }
}
//-------------------------------- 


//---------------------------------------------------------------------------------
function scroll_left()
{
WHILE(mouse_strafe && rts)
 {
  IF(MOUSE_POS.X<=2&&!MOUSE_LEFT) 
  {
  set_dir_for_cam();
  temp.x = SAT.SKILL11;
  temp.y = SAT.SKILL12;
  temp.z = SAT.SKILL13;
  vec_scale(temp,TIME);
  IF(KEY_SHIFT==1) { vec_scale(temp,2); } 
  IF(KEY_Q==1) { vec_scale(temp,0.1); }
  MOVE SAT,NULLSKILL,SAT.SKILL11;
  block_on_boundary();
  }
 WAIT 1;
 }
}
//-------------------------------- 


//---------------------------------------------------------------------------------
function scroll_right()
{
WHILE(mouse_strafe && rts)
 {
  IF(MOUSE_POS.X>=SCREEN_SIZE.X-2&&!MOUSE_LEFT) 
  {
  set_dir_for_cam();
  temp.x = SAT.SKILL8;
  temp.y = SAT.SKILL9;
  temp.z = SAT.SKILL10;
  vec_scale(temp,TIME);
  IF(KEY_SHIFT==1) { vec_scale(temp,2); }
  IF(KEY_Q==1) { vec_scale(temp,0.1); }
  MOVE SAT,NULLSKILL,SAT.SKILL8;
  block_on_boundary();
  }
 WAIT 1;
 }
}
//--------------------------------


//---------------------------------------------------------------------------------
//this function keeps track of mouse coordinates while in strafe/select mode
function mouse_coords()
{
WHILE(mouse_strafe)
 {
 MOUSE_POS.X += 0.8*MICKEY.X;
 MOUSE_POS.Y += 0.8*MICKEY.Y;
 WAIT 1;
 }
}
//--------------------------------


//---------------------------------------------------------------------------------
//this function is used to select free look OR select/strafe mouse
function select_mouse_mode
{
IF(rts == 0) { RETURN ;}
//PLAY_SOUND toggle_freelook_sound,50;
mouse_strafe = 1 - mouse_strafe;

//free look
IF(mouse_strafe==0)
   {
   MOUSE_MODE = 0;         
   mouse_rotate();
   }

//strafe/select
IF(mouse_strafe==1)
   {
   MOUSE_MODE = 1;
   MOUSE_POS.X = SCREEN_SIZE.X/2;
   MOUSE_POS.Y = SCREEN_SIZE.Y/2;
   scroll_left();
   scroll_right();
   scroll_up();
   scroll_down();
   mouse_coords();
   }
}
//--------------------------------


//---------------------------------------------------------------------------------
//this function sets the "direction" for the movement of camera
//scaled by time correction in scroll functions
var temp_ahead;
var temp_back;
var temp_right;
var temp_left;

function set_dir_for_cam()
{
//direction ahead
temp_ahead.PAN = SAT.PAN;
SAT.SKILL2 = 500;
SAT.SKILL3 = 0;
SAT.SKILL4 = 0;
VECROTATE SAT.SKILL2,temp_ahead.PAN;
NORMALIZE SAT.SKILL2,camera_speed;

//direction back
temp_back.PAN = SAT.PAN +180;
SAT.SKILL5 = 500;
SAT.SKILL6 = 0;
SAT.SKILL7 = 0;
VECROTATE SAT.SKILL5,temp_back.PAN;
NORMALIZE SAT.SKILL5,camera_speed;

//direction right
temp_right.PAN = SAT.PAN - 90;
SAT.SKILL8 = 500;
SAT.SKILL9 = 0;
SAT.SKILL10 = 0;
VECROTATE SAT.SKILL8,temp_right.PAN;
NORMALIZE SAT.SKILL8,camera_speed;

//direction left
temp_left.PAN = SAT.PAN + 90;
SAT.SKILL11 = 500;
SAT.SKILL12= 0;
SAT.SKILL13 = 0;
VECROTATE SAT.SKILL11,temp_left.PAN;
NORMALIZE SAT.SKILL11,camera_speed;
}
//-----------------


//---------------------------------------------------------------------------------
//this sets the camera with the satellite always
function set_cam()
{
WHILE(1)
  {
   SONAR ME,5000;
   //MY.Z = TARGET.Z + 2500;
   CAMERA.PAN  = SAT.PAN;
   CAMERA.TILT = SAT.TILT;
   CAMERA.ROLL = SAT.ROLL;
   CAMERA.X    = SAT.X;
   CAMERA.Y    = SAT.Y;
   CAMERA.Z    = SAT.Z;
   WAIT 1;
  }
}
//-------------


//---------------------------------------------------------------------------------
//this function rotates the satellite view thru the mouse
function mouse_rotate()
{
WHILE(mouse_strafe==0 && rts == 1)
  {
  //SONAR ME,10000;
  //SAT.Z = TARGET.Z + 600;  

  //pan satellite
  temp = MOUSE_FORCE.X*rotate_strength*free_look;
  IF(KEY_Q == 1) { temp *= 0.2;}
  SAT.PAN -= temp;
  
  //move satellite
  temp.X = zoom_speed*-MOUSE_FORCE.Y;
  IF(KEY_SHIFT) {temp.X *= 1.5;}//boost the zoom speed
  temp.Y = 0;
  temp.Z = 0;
  cam_temp_ang.PAN = CAMERA.PAN;
  cam_temp_ang.TILT = 140;
  VECROTATE temp,cam_temp_ang;            
  MOVE SAT,NULLSKILL,temp;

  //restrict zoom and movement
  block_on_boundary();
    
  //tilt satellite
  SAT.TILT = (sat_tilt*(SAT.Z - min_zoom_height))/(min_zoom_height - max_zoom_height);
  
  //SAT.TILT+= MOUSE_FORCE.Y*rotate_strength;
  //SAT.TILT = min(SAT.TILT,-12);
  WAIT 1;
  }

}
//--------------------------------



//---------------------------------------------------------------------------------
//this function moves camera ahead
ACTION sat_up
{
IF(SAT==NULL) { RETURN;}//so that initial key presses do not interfere
NORMALIZE SAT.SKILL2,camera_speed;
WHILE(key_e)
  {
  temp.x = SAT.SKILL2;
  temp.y = SAT.SKILL3;
  temp.z = SAT.SKILL4;
  IF(KEY_SHIFT==1) { vec_scale(temp,2); }
  IF(KEY_Q==1) { vec_scale(temp,0.1); }
  MOVE SAT,NULLSKILL,temp;
  block_on_boundary();
  WAIT 1;
  }
}
//--------------------------------


//---------------------------------------------------------------------------------
//this function moves back camera
ACTION sat_down
{
IF(SAT==NULL) { RETURN;}//so that initial key presses do not interfere
NORMALIZE SAT.SKILL5,camera_speed;
WHILE(key_c)
  {
  temp.x = SAT.SKILL5;
  temp.y = SAT.SKILL6;
  temp.z = SAT.SKILL7;
  IF(KEY_SHIFT==1) { vec_scale(temp,2); }
  IF(KEY_Q==1) { vec_scale(temp,0.1); }
  MOVE SAT,NULLSKILL,temp;
  block_on_boundary();
  WAIT 1;  
  }
}
//--------------------------------


//---------------------------------------------------------------------------------
//this function rotates camera right
ACTION sat_right
{
IF(SAT==NULL) { RETURN;}//so that initial key presses do not interfere
NORMALIZE SAT.SKILL8,camera_speed;
WHILE(key_f)
  {
  temp.x = SAT.SKILL8;
  temp.y = SAT.SKILL9;
  temp.z = SAT.SKILL10;
  IF(KEY_SHIFT==1) { vec_scale(temp,2); }
  IF(KEY_Q==1) { vec_scale(temp,0.1); }
  MOVE SAT,NULLSKILL,temp;
  block_on_boundary();
  WAIT 1;
  }
}
//--------------------------------


//---------------------------------------------------------------------------------
//this function rotates the camera left
ACTION sat_left
{
IF(SAT==NULL) { RETURN;}//so that initial key presses do not interfere
NORMALIZE SAT.SKILL11,camera_speed;
WHILE(key_s)
  {
  temp.x = SAT.SKILL11;
  temp.y = SAT.SKILL12;
  temp.z = SAT.SKILL13;
  IF(KEY_SHIFT==1) { vec_scale(temp,2); }
  IF(KEY_Q==1) { vec_scale(temp,0.1); }
  MOVE SAT,NULLSKILL,temp;
  block_on_boundary();
  WAIT 1;
  }
}
//--------------------------------



//---------------------------------------------------------------------------------
//for quick telescopic zoom
function telescopic_zoom()
{
IF(KEY_X || KEY_Z) { RETURN;}
WHILE(KEY_Q==1)
  {
   CAMERA.ARC -= 7*TIME;
   CAMERA.ARC = max(CAMERA.ARC,25);
   WAIT 1;
  }
CAMERA.ARC = 60;
//IF(CAMERA.ARC == 60) { CAMERA.ARC = 10;RETURN; }
//IF(CAMERA.ARC == 10) { CAMERA.ARC = 60;RETURN; }
}
//------------------

//-----------------------------------------------------
function  block_on_boundary()
{
SAT.x = min(max_level_x,SAT.x);
SAT.x = max(min_level_x,SAT.x);
SAT.y = min(max_level_y,SAT.y);
SAT.y = max(min_level_y,SAT.y);
SAT.z = min(max_zoom_height,SAT.z);
SAT.z = max(min_zoom_height,SAT.z);
}
//-------


//--------------------------------------------------------------------------------
function free_look_toggle()
{
free_look = 1 - free_look;
}
//-------


//---------------------------------------------------------------------------------
//now assign keys  to actions
//ON_E sat_up;
//ON_C sat_down;
//ON_F sat_right;
//ON_S sat_left;
//ON_Z zoom_in;
//ON_X zoom_out;
//ON_Q telescopic_zoom;
ON_G select_mouse_mode;
ON_MOUSE_MIDDLE select_mouse_mode;
ON_W free_look_toggle;
//--------------------------------


