//********THIS FILE DEALS WITH THE CREATION OF THE DRAG BOX AND SETTING DESTINATION POINT ON LCLICK******--------

//----------------Var Definitions-----------------------------
Var start[3];
Var end[3];

var click_point[3] = 0,0,0;
var other_point[3] = 0,0,0;

var top_no =0;
var bottom_no =0;
var left_no =0;
var right_no =0;

var should_set_destination = 0;
var target_click_point[3];
//------------------


//-----------------Bitmap Definitions--------------------------
BMAP drag_box_hor_line,<yellow.pcx>,0,0,1,1;
BMAP drag_box_ver_line,<yellow.pcx>,0,0,1,1;
//------------------


//-----------------Panel Definitions----------------------------
PANEL topline
{
layer = 40;
pos_x = 0;
pos_y = 0;
flags = refresh,d3d;
hbar = 0,0,900,drag_box_hor_line,1,top_no;
}

PANEL bottomline
{
layer = 40;
pos_x = 0;
pos_y = 0;
flags = refresh,d3d;
hbar = 0,0,900,drag_box_hor_line,1,bottom_no;
}

PANEL leftline
{
layer = 40;
pos_x = 0;
pos_y = 0;
flags = refresh,d3d;
vbar = 0,0,900,drag_box_ver_line,1,left_no;
}

PANEL rightline
{
layer = 40;
pos_x = 0;
pos_y = 0;
flags = refresh,d3d;
vbar = 0,0,900,drag_box_ver_line,1,right_no;
}
//--------------


//---------------------------------------------
function store_other_point()
{
WHILE(MOUSE_LEFT)
  {
  other_point.X = MOUSE_POS.X; 
  other_point.Y = MOUSE_POS.Y; 
  WAIT 1;
  }
}
//---------------


//-------------------------------------------------------------------------------
function target_sprite_blink()
{
     MY.ORIENTED = ON;
     MY.FLARE = ON;
     MY.LIGHT = ON;
     MY.BRIGHT = ON;
     MY.LIGHTBLUE =  60;
     MY.LIGHTGREEN = 50;
     MY.LIGHTRANGE =  200;	

			
				if ((NORMAL.x != 0) || (NORMAL.y != 0))
				{ // we're on a slope
					// rotate the floor normal relative to the shadow
					vec_set(temp,nullvector); // set temp tilt and roll to 0
					temp.pan = -MY.PAN;
					vec_rotate(NORMAL,temp);
					// calculate the destination tilt and roll angles
					MY.tilt = 90-asin(NORMAL.x);
					MY.roll = -asin(NORMAL.y);
				}
				else
				{
					MY.tilt = 90; // set it flat onto the floor
					MY.roll = 0;
				}
WHILE(MY.SCALE_X>=0)
  {
   MY.SCALE_X -= 0.08*TIME;
   MY.SCALE_Y -= 0.08*TIME;
   MY.LIGHTRANGE -= 10*TIME;
   WAIT 1;
 }
REMOVE ME;
}
//-------------



//-------------------------------------------------------------------------------------------------
function reset_destination_point()
{
WAIT 2;
should_set_destination = 0;
}
//----------


//---------------------------------------------------------------------------------------------------
ACTION create_dragbox
{
//create dragbox only if these conditions are fullfilled
IF(FREEZE_MODE==1) {RETURN;}
     
//shoot towards level to set target move point
start.X = MOUSE_POS.X;
start.Y = MOUSE_POS.Y;
start.Z = 0;
vec_for_screen(start,CAMERA);
end.X =   MOUSE_POS.X;
end.Y =   MOUSE_POS.Y;
end.Z =   40000;
vec_for_screen(end,CAMERA);
SHOOT start,end;

//if clicked point beyond boundaries)
IF( TARGET.X >= min_level_x && TARGET.X <= max_level_x && TARGET.Y >= min_level_y && TARGET.Y <= max_level_y)  
  {
  vec_set(target_click_point.X,TARGET.X);
  should_set_destination = 1;
  reset_destination_point();
  }
//store the point on screen where it is clicked and the other point as 
//same as clicked point to avoid previos line draws
click_point.X = MOUSE_POS.X;
click_point.Y = MOUSE_POS.Y;
click_point.Z = 0;
other_point.X = MOUSE_POS.X;
other_point.Y = MOUSE_POS.Y;
other_point.Z = 0;
top_no  = 0;
bottom_no = 0;
right_no = 0;
left_no = 0;

//continously update the other points x and y coordinates
store_other_point();


//keep drawing the dragbox
WHILE(MOUSE_LEFT)
  {
  //calculate length of each side of dragbox
  top_no = ABS(other_point.X - click_point.X);
  bottom_no = ABS(other_point.X - click_point.X);
  left_no = ABS(other_point.Y - click_point.Y);
  right_no = ABS(other_point.Y - click_point.Y);
  
  //set position of each side of dragbox
  topline.pos_x = click_point.X;
  IF(other_point.X < click_point.X) {  topline.pos_x = other_point.X; }
  topline.pos_y =  click_point.Y;
  IF(other_point.Y < click_point.Y) {  topline.pos_y = other_point.Y; }

  bottomline.pos_x = click_point.X;
  IF(other_point.X < click_point.X) {  bottomline.pos_x = other_point.X;}
  bottomline.pos_y = other_point.Y;
  IF(other_point.Y <  click_point.Y){  bottomline.pos_y = click_point.Y; }
  

   
  leftline.pos_x = click_point.X;
  IF(other_point.X < click_point.X) {  leftline.pos_x = other_point.X; }
  leftline.pos_y = click_point.Y;
  IF(other_point.Y < click_point.Y) {  leftline.pos_y = other_point.Y; }

  
  rightline.pos_x = other_point.X; 
  IF(other_point.X < click_point.X) {  rightline.pos_x = click_point.X;}
  rightline.pos_y = click_point.Y;
  IF(other_point.Y < click_point.Y)  {  rightline.pos_y = other_point.Y; }
  
  //make dragbox right and left panels visible
  IF(top_no!=0) { topline.VISIBLE = ON;bottomline.VISIBLE = ON;}
  ELSE { topline.VISIBLE = OFF;bottomline.VISIBLE = OFF;}
  IF(left_no!=0) { leftline.VISIBLE = ON;rightline.VISIBLE = ON;}
  ELSE { leftline.VISIBLE = OFF;rightline.VISIBLE = OFF;}


  WAIT 1;
  }

//Clear the dragbox
topline.visible = OFF;
bottomline.VISIBLE = OFF;
rightline.VISIBLE = OFF;
leftline.VISIBLE = OFF;
click_point.X = MOUSE_POS.X;
click_point.Y = MOUSE_POS.Y;
click_point.Z = 0;
}
//---------------



