
//-----------Defines----------------------------------

//frames values
DEFINE FRM_MANCER_STAND_START,121;
DEFINE FRM_MANCER_STAND_END,141;
DEFINE FRM_MANCER_WALK_START,11;
DEFINE FRM_MANCER_WALK_END,51;
DEFINE FRM_MANCER_RUN_START,73;
DEFINE FRM_MANCER_RUN_END,112;
DEFINE FRM_MANCER_ATTACKHIGH_START,149;
DEFINE FRM_MANCER_ATTACKHIGH_END,155;
DEFINE FRM_MANCER_ATTACKMEDIUM_START,169;
DEFINE FRM_MANCER_ATTACKMEDIUM_END,175;
DEFINE FRM_MANCER_ATTACKLOW_START,189;
DEFINE FRM_MANCER_ATTACKLOW_END,195;
DEFINE FRM_MANCER_PAINWEAK_START,240;
DEFINE FRM_MANCER_PAINWEAK_END,252;
DEFINE FRM_MANCER_PAINSTRONG_START,253;
DEFINE FRM_MANCER_PAINSTRONG_END,271;
DEFINE FRM_MANCER_DIEWEAK_START,272;
DEFINE FRM_MANCER_DIEWEAK_END,295;
DEFINE FRM_MANCER_DIESTRONG_START,296;
DEFINE FRM_MANCER_DIESTRONG_END,305;

//animation speed values
DEFINE FRM_MANCER_STAND_ANIMSPEED,0.3;
DEFINE FRM_MANCER_WALK_ANIMSPEED,2.4;
DEFINE FRM_MANCER_RUN_ANIMSPEED,4.9;
DEFINE FRM_MANCER_ATTACKHIGH_ANIMSPEED,1.5;
DEFINE FRM_MANCER_ATTACKLOW_ANIMSPEED,1.4;
DEFINE FRM_MANCER_ATTACKMEDIUM_ANIMSPEED,1;
DEFINE FRM_MANCER_PAINWEAK_ANIMSPEED,1.8;
DEFINE FRM_MANCER_PAINSTRONG_ANIMSPEED,1.8;
DEFINE FRM_MANCER_DIEWEAK_ANIMSPEED,1.2;
DEFINE FRM_MANCER_DIESTRONG_ANIMSPEED,2;

//miscellaneous defines
DEFINE MANCER_START_HEALTH,100;
DEFINE MANCER_WALK_DIST,1.8;
DEFINE MANCER_RUN_DIST,7;
DEFINE MANCER_SCANCONE_RADIUS,1000;
DEFINE MANCER_SCANCONE_PAN,260;
DEFINE MANCER_SCANCONE_TILT,180;
DEFINE MANCER_BULLET_SPEED,50;
DEFINE MANCER_BULLET_DAMAGE,10;
DEFINE MANCER_PAIN_AGAIN_INTERVAL,32;
DEFINE MANCER_PATROL_WAIT_INTERVAL,48;
DEFINE MANCER_WEAPONFLASH_VERTEX,822;

//--------


//----------Vars--------------------------------------
var mancer_bullet_vector;
var temp_vec_behind;
//--------


//----------Sounds------------------------------------
SOUND snd_mancer_growl1,<mancer1.wav>;
SOUND snd_mancer_bullet,<plasmx1a.wav>;
SOUND snd_mancer_pain1,<mancer2.wav>;
SOUND snd_mancer_bodygib1,<bodygib.wav>;
//--------


//----------Images------------------------------------
//bmap bmp_mancer_blood = <gpart1.pcx>;
//bmap bmp_mancer_blood = <sparkle.bmp>;
//bmap bmp_mancer_blood = <blood.bmp>;
bmap bmp_mancer_blood = <blood.pcx>;
//--------


//The main mancer action
//----------------------------------------------------
function mancer_main()
{
WHILE(player == NULL) { WAIT 1;}
//initialise parameters for mancer
mancer_initialise();

//apply gravity to mancer
entity_apply_gravity();

//play animation frames of mancer
mancer_play_animations();

//test action anly
//macer_random_destinations();

//keep moving mancer to its destination
mancer_move_to_target();

//flip mancer in between
mancer_tilt_randomly();

//mancer play sound randomly
mancer_sounds_random();

//makes mancer invisible
mancer_invisible_random();

//makes mancer brighter in robo mode
mancer_brighter_robomode();
}
//-----------

//----------------------------------
function mancer_brighter_robomode()
{
WHILE(my.HEALTH >= 1 )
   {
    IF(player_mode == ROBOMODE) { my.AMBIENT = 100;my.BRIGHT = ON;}
    ELSE { my.AMBIENT = 0;my.BRIGHT = OFF;}
    WAITT 8;//longer waitt for better fps
   }
}
//--------
    
  
//----------------------------------
function mancer_invisible_random()
{
WHILE(my.HEALTH >= 1)
   {
    my.ALPHA = 100; 
    temp = 200 + random(100);
    WAITT temp;
    my.LIGHT = ON;
    my.LIGHTGREEN = 150;
    my.LIGHTRANGE = 20;
    my.TRANSPARENT = ON;
      WHILE(my.ALPHA >= 15)
         { 
          my.ALPHA -= 5*TIME;
          WAIT 1;
         }
    my.LIGHTRANGE = 0;
    my.LIGHTGREEN = 0;
    my.ALPHA = 15;
    temp = 20 + random(20);
    WAITT temp;
    
    my.LIGHT = ON;
    my.LIGHTGREEN = 150;
    my.LIGHTRANGE = 20;

      WHILE(my.ALPHA <= 95)
         { 
          my.ALPHA += 5*TIME;
          WAIT 1;
         }     
    my.LIGHT = OFF;
    my.LIGHTGREEN = 0;
    my.LIGHTRANGE = 0;

    }
}
//---------- 


//---------------------------------------------------
function mancer_sounds_random()
{
WHILE(my.HEALTH >= 1)
  {
   PLAY_ENTSOUND ME,snd_mancer_growl1,900;
   temp = 50 + random(60);
   WAITT temp;
  }
}
//----------

//----------------------------------------------------
function mancer_tilt_randomly()
{
WHILE(my.HEALTH >= 1)
  {
   my.TILT = 0;
   temp = 100 + random(100);
   WAIT temp;
  //tilt only when running
  WHILE(my.FRAMES_TO_PLAY != RUNNING) { WAIT 1;}
  WHILE(my.TILT >= -359 && my.HEALTH >= 1 && my.FRAMES_TO_PLAY == RUNNING)
       {
       my.TILT -= 40*TIME;
       WAIT 1;
      }
   IF(my.HEALTH <= 0) { RETURN ;}
  }
}
//----------

 
//this function moves the mancer
//to its destination continuosly
//----------------------------------------------------
function mancer_move_to_target()
{
WHILE(my.HEALTH >= 1)
  {
  //calculate direction vector to destination
  temp.X = my.TARGET_X - my.X;
  temp.Y = my.TARGET_Y - my.Y;
  temp.Z = 0;
 
  //decide speed according to animation type
  IF(my.FRAMES_TO_PLAY == WALKING)
    {
    vec_normalize(temp,MANCER_WALK_DIST);
    }
  IF(my.FRAMES_TO_PLAY == RUNNING)
    {
    vec_normalize(temp,MANCER_RUN_DIST);
    }
  IF(my.FRAMES_TO_PLAY != WALKING && my.FRAMES_TO_PLAY != RUNNING)
    {
    vec_normalize(temp,0);
    }   

  //time correct the speed
  vec_scale(temp,TIME);

  //now move the mancer
  move_mode = GLIDE+ignore_passable+ignore_passents;
  result = ent_move(nullskill,temp);
 
  WAIT 1;
  }
}
//-------------


//----------------------------------------------------
function macer_random_destinations()
{
WHILE(1)
  {
  vec_set(my.TARGET_X,player.X);
  WAIT 1;
  }
}
//--------


//mancer that patrols on a path
//branch to mancer_main function
//----------------------------------------------------
ACTION mancer_patrol
{
//patrol
my.FLAG1 = ON;
mancer_main();
}
//-----------


//mancer that stands still 
//branch to mancer_main function
//----------------------------------------------------
ACTION mancer_stand
{
//don't patrol
my.FLAG1 = OFF;
mancer_main();
}
//-----------


//mancer's event action
//------------------------------------------------------
function mancer_event_action()
{

//shot by player
IF(EVENT_TYPE == EVENT_SHOOT && indicator == _GUNFIRE)
  {
  //if dead state then gib
  IF(my.HEALTH <= 0) { my.ENABLE_SHOOT = OFF;mancer_gib();RETURN;} 

  //play pain sound
  play_entsound me,snd_mancer_pain1,800;
  //mancer's green blood
  mancer_blood_spurt();  

  //reset indicator to avoid conflicts
  indicator = -10; 
  //first calculate damage and reduce health
  damage = 5 + random(10);
  my.HEALTH -= damage;
  
  //kill mancer 
  IF(my.HEALTH <= 0) { 
                     //if below 0 then nullify mancer  
                     mancer_nullify();
                     //if health very low,then gib
                     //else decide between weak and
                     //strong die
                     IF(my.HEALTH <= -20) { mancer_gib();RETURN;}
                     IF(my.HEALTH <= -10) { my.FRAMES_TO_PLAY = DYINGSTRONG;mancer_death_animation();}
                     ELSE { my.FRAMES_TO_PLAY = DYINGWEAK;mancer_death_animation();}
                     RETURN;
                     }

  //if already playing pain frames
  IF(my.PAIN_FRAMES_PLAYING == 1) { RETURN ;}
  //store previous animation that was playing
  my.SKILL48 = my.FRAMES_TO_PLAY;
  my.PAIN_FRAMES_PLAYING = 1;
  IF(damage <= 10) { my.FRAMES_TO_PLAY = PAININGWEAK;}
  ELSE { my.FRAMES_TO_PLAY = PAININGSTRONG;}
 
  //attack player
  IF(my.ATTACKED_PLAYER_ONCE == 0) { 
 						 my.ATTACKED_PLAYER_ONCE = 1;
                                     mancer_run_and_attack();
                                   } 

  RETURN;
  }

//if player detected by scanning
IF(EVENT_TYPE == EVENT_DETECT && YOU == player && indicator == 100)
  {
   indicator = 0;
   my.ATTACKED_PLAYER_ONCE = 1;
   mancer_run_and_attack();
   RETURN;
  }

//if grenade explodes
IF(EVENT_TYPE == EVENT_SCAN && indicator == _EXPLODE)
  {
  //indicator = 0;
  my.HEALTH -= ((range - RESULT)/range)*range;

  //play pain sound
  play_entsound me,snd_mancer_pain1,800;
  //mancer's green blood
  mancer_blood_spurt();  

  //reset indicator to avoid conflicts
  indicator = -10; 
  
  //kill mancer 
  IF(my.HEALTH <= 0) { 
                     //if below 0 then nullify mancer  
                     mancer_nullify();
                     //if health very low,then gib
                     //else decide between weak and
                     //strong die
                     IF(my.HEALTH <= -10) { mancer_gib();RETURN;}
                     IF(my.HEALTH <= -5) { my.FRAMES_TO_PLAY = DYINGSTRONG;mancer_death_animation();}
                     ELSE { my.FRAMES_TO_PLAY = DYINGWEAK;mancer_death_animation();}
                     RETURN;
                     }

  //if already playing pain frames
  IF(my.PAIN_FRAMES_PLAYING == 1) { RETURN ;}
  //store previous animation that was playing
  my.SKILL48 = my.FRAMES_TO_PLAY;
  my.PAIN_FRAMES_PLAYING = 1;
  IF(damage <= 10) { my.FRAMES_TO_PLAY = PAININGWEAK;}
  ELSE { my.FRAMES_TO_PLAY = PAININGSTRONG;}
 
  //attack player
  IF(my.ATTACKED_PLAYER_ONCE == 0) { 
 						 my.ATTACKED_PLAYER_ONCE = 1;
                                     mancer_run_and_attack();
                                   } 



  RETURN; 
  }
}
//-----------
 

//stop mancer's movement and make it
//a dead as a table type object
//-------------------------------------------------------------------
function mancer_nullify()
{
my.ROLL = 0;
//my.PASSABLE = ON;
//my.EVENT = NULL;
//my.ENABLE_SCAN = OFF;
my.ENABLE_DETECT = OFF;
my.ENABLE_ENTITY = OFF;
my.ENABLE_IMPACT = OFF;
//my.ENABLE_SHOOT = OFF;//set after its completely gibbed
WAIT 1;
}
//-------------


//gib mancer's body
//-------------------------------------------------------------------
function mancer_gib()
{
play_entsound me,snd_mancer_bodygib1,1000;
my.INVISIBLE = ON;
WAIT 1;
my.SKILL1 = 0;
WHILE(my.SKILL1 != 6)
  {
  IF(random(1) > 0.5) { CREATE <mancgib1.mdl>,my.X,mancer_gib_fly;}
  ELSE  { CREATE <mancgib2.mdl>,my.X,mancer_gib_fly;}
  my.SKILL1 += 1;
  WAIT 1; 
  }
WAIT 3;
REMOVE ME;
}
//----------


//mancer's gib event
//-----------------------------------------------------
function mancer_gib_event()
{
IF(EVENT_TYPE == EVENT_BLOCK)
    {
    mancer_gib_remove();
    RETURN;
    }
}
//-----------   

//make mancer's gib fly
//------------------------------------------------------
function mancer_gib_fly()
{
/*
//make it collidable with walls
my.ENABLE_BLOCK = ON;
my.FAT = ON;
my.NARROW = ON;
my.MIN_X *= 0.1;
my.MIN_Y *= 0.1;
my.MIN_Z *= 0.1;
my.MAX_X *= 0.1;
my.MAX_Y *= 0.1;
my.MAX_Z *= 0.1;
*/
my.PASSABLE = ON;

//scale the gib
temp = 0.3 + random(0.2);
vec_scale(my.SCALE_X,temp);

//set direction of gib
temp = 1;
IF(random(10) >= 5) {temp = -1;}
my.SKILL1 = temp*3;
temp = 1;
IF(random(10) >= 5) {temp = -1;}
my.SKILL2 = temp*3;
my.SKILL3 = 12 + random(6) ;

my.EVENT = mancer_gib_event;
//counter to remove gib
my.SKILL4 = 0;
WHILE(my.SKILL4 != 200)
  {
  //decrease height
  my.SKILL3 -= 3*TIME;
  vec_set(temp.X,my.SKILL1);
  vec_scale(temp.X,TIME);
  MOVE ME,NULLSKILL,temp;
  IF(my.SKILL4 % 4 == 0) { mancer_blood_drop(); }
  //IF(my.SKILl4 % 15 == 0) { CREATE <blood.>,my.X,mancer_gib_blood;}
  my.SKILL4 += 1;
  my.TILT += random(10*TIME);
  my.ROLL -= random(20*TIME);
  WAIT 1;
  }
WAIT 1;
REMOVE ME;
}
//-------------


//remove mancer's gib
//------------------------------------------------------
function mancer_gib_remove()
{
my.EVENT = NULL;
EXCLUSIVE_ENTITY;
WAIT 1;
WHILE(my.SKILL4 != 200)
   {
    my.SKILL4 += 1;
    WAIT 1;
   }
my.TRANSPARENT = ON;
my.ALPHA = 100;
WHILE(my.ALPHA >= 0)
  {
  my.ALPHA -= 5*TIME;
  WAIT 1;
  }
}
//-------------


//mancer's blood Q3 style
//------------------------------------------------------
function mancer_gib_blood()
{
my.PASSABLE = ON;
my.OVERLAY = ON;
my.FLARE = ON;
vec_scale(my.SCALE_X,0.07);
my.LIGHTGREEN = 100;
my.LIGHTRANGE = 10;
WHILE(my.SKILL1 != 100)
   {
    my.Z -= 3*TIME;
    my.SCALE_Y += 0.02*TIME;
    my.SCALE_X += 0.006*TIME;
    WAIT 1;
   }
REMOVE ME;
}
//-----------


//------------------------------------------------------
function mancer_pain_wait()
{
my.SKILL48 = my.FRAMES_TO_PLAY;
WAITT 24;
my.FRAMES_TO_PLAY = my.SKILL48;
}
//------------

 
//run and attack player
//------------------------------------------------------
function mancer_run_and_attack()
{
my.AI_MODE = RUN_AND_ATTACK;
WAIT 1;
WHILE(my.AI_MODE == RUN_AND_ATTACK && my.HEALTH >= 1)
   {
   WHILE(my.PAIN_FRAMES_PLAYING == 1) 
      {
       WAIT 1;
      }
   IF(my.HEALTH <= 0) { RETURN; }   
  
   vec_set(temp.X,player.X);
   vec_sub(temp.X,my.X);
   vec_to_angle(temp_pan,temp.X);
   my.PAN = temp_pan.PAN;
   SHOOT my.POS,player.POS;
   IF(YOU == player)
     {      
      my.FRAMES_TO_PLAY = ATTACKINGMEDIUM;
      IF(player.Z > my.Z + 100) {  my.FRAMES_TO_PLAY = ATTACKINGHIGH;}
      IF(player.Z < my.Z - 20) {  my.FRAMES_TO_PLAY = ATTACKINGLOW;}
      }
    ELSE
     {
      my.FRAMES_TO_PLAY = RUNNING;
      mancer_patrol_and_scan(); 
      mancer_search_player_sometime();
     }
    WAIT 1;
   }
}
//--------


//search for player for some time
//if not found then again start patrolling
//-----------------------------------------------------
function mancer_search_player_sometime()
{
my.SEARCH_PLAYER_COUNTER = 0;
WHILE(my.AI_MODE == PATROL_AND_SCAN && my.HEALTH >= 1)
   {
   my.SEARCH_PLAYER_COUNTER += 1;
   IF(my.SEARCH_PLAYER_COUNTER == 400)
     {
      BREAK;
     }
    WAITT 1;
   }
IF(my.HEALTH <= 0) { RETURN;}
my.ATTACKED_PLAYER_ONCE = 0;
my.RANDOM_STAND_WALK_WAIT = 0;
}
//------------
        

//to initialise mancer
//------------------------------------------------------
function mancer_initialise()
{
//set some misc flags
my.FAT = ON;
my.NARROW = ON;
my.SHADOW = ON;

//set enable flags
my.ENABLE_SHOOT = ON;
my.ENABLE_SCAN = ON;
my.ENABLE_DETECT = ON;

vec_scale(my.SCALE_X,1.2);
my.HEALTH = MANCER_START_HEALTH;

//find a path in a full sphere 
temp.PAN = 360;
temp.TILT = 180;
temp.Z = 1000;
result = scan_path(my.X,temp.X);
IF(result == 0) { RETURN ;}
ent_waypoint(my.TARGET_X,1);

//patrol or stand and scan for player
IF(my.FLAG1 == ON) {
                    my.FRAMES_TO_PLAY = WALKING;
                    mancer_patrol_and_scan();
                    }

ELSE                {
                    my.FRAMES_TO_PLAY = STANDING;
                    mancer_stand_and_scan();
                    }

//set event action
my.EVENT = mancer_event_action;

}
//-----------
 
//make mancer to patrol
//-----------------------------------------------------
function mancer_patrol_and_scan()
{
my.AI_MODE = PATROL_AND_SCAN;
WAIT 1;
WHILE(my.AI_MODE == PATROL_AND_SCAN && my.HEALTH >= 1)
  {
  
 //make mancer stand or walk randomly whilst not attacked player once
  IF(my.ATTACKED_PLAYER_ONCE == 0 && my.RANDOM_STAND_WALK_WAIT == 0)
    {
    mancer_walkstand_counter();
    //more probability of walking 80 : 20 odds
    temp = random(100);
    IF(temp<=80)
       {
        my.FRAMES_TO_PLAY = WALKING;
       }
    ELSE
       {
        my.FRAMES_TO_PLAY = STANDING;
       }
     }

  //calculate distance to target 
  temp.X = my.TARGET_X - my.X;
  temp.Y = my.TARGET_Y - my.Y;
  temp.Z = 0;

  //rotate to target
  result = vec_to_angle(temp_pan,temp);
  my.PAN = temp_pan.PAN;  

  //if near to waypoint,then find next waypoint 
  IF(result <= 10)
     {
     ent_nextpoint(my.TARGET_X);
     }
  
  //in one frame scan ahead
  //in next frame scan behind
  //flag2 = 1 -> scan ahead
  //flag2 = 0 -> scan behind
  my.FLAG2 = 1 - my.FLAG2;

  IF(my.FLAG2 == 1)
     {    
     //now scan for player ahead
     temp.PAN  = MANCER_SCANCONE_PAN;
     temp.TILT = MANCER_SCANCONE_TILT;
     temp.Z    = MANCER_SCANCONE_RADIUS;
     indicator = 100;
     SCAN my.POS,my.ANGLE,temp;  
     }
  ELSE
     {    
     //now scan for player behind at 1/3rd range
     temp.PAN  = MANCER_SCANCONE_PAN;
     temp.TILT = MANCER_SCANCONE_TILT;
     temp.Z    = MANCER_SCANCONE_RADIUS*0.33;
     vec_set(temp_vec_behind.PAN,my.ANGLE);
     temp_vec_behind.PAN += 180;
     indicator = 100;
     SCAN my.POS,temp_vec_behind.PAN,temp;  
     }

   WAIT 1;
  }
}
//---------


//-----------------------------------------------------
function mancer_walkstand_counter()
{
WHILE(my.RANDOM_STAND_WALK_WAIT != 200 && my.HEALTH >= 1)
   {
   my.RANDOM_STAND_WALK_WAIT += 1;
   WAIT 1;
   }
my.RANDOM_STAND_WALK_WAIT = 0;
}
//---------


//make mancer to stand
//-----------------------------------------------------
function mancer_stand_and_scan()
{
my.AI_MODE = STAND_AND_SCAN;
WHILE(my.AI_MODE == STAND_AND_SCAN && my.HEALTH >= 1)
  {
  //scan for player
  
   temp.PAN  = MANCER_SCANCONE_PAN;
   temp.TILT = MANCER_SCANCONE_TILT;
   temp.Z    = MANCER_SCANCONE_RADIUS;
   indicator = 100;
   SCAN my.POS,my.ANGLE,temp;  
   WAIT 1;
  }
}
//---------

//----------------------------------------------------
function mancer_wait_attack()
{
my.FLAG3 = 1;
WAITT 8;
my.FLAG3 = 0;
}
//-------

//Plays mancer's animation according to 
//the value in FRAMES_TO_WALK skill
//-----------------------------------------------------
function mancer_play_animations()
{
WHILE(my.HEALTH >= 1)
   {
   //standing animation 
   IF(my.FRAMES_TO_PLAY == STANDING)
       {
        my.FRAME = FRM_MANCER_STAND_START;
        WHILE(my.FRAMES_TO_PLAY == STANDING && my.HEALTH >= 1)
           {
            my.FRAME +=FRM_MANCER_STAND_ANIMSPEED*TIME;
            IF(my.FRAME > FRM_MANCER_STAND_END) 
                 {
                 my.NEXT_FRAME = FRM_MANCER_STAND_START;
                 }
            ELSE
                 {
                 my.NEXT_FRAME = 0;
                 }
            IF(my.FRAME >= FRM_MANCER_STAND_END + 1)
                 {
                 my.FRAME = FRM_MANCER_STAND_START;
                 }
            WAIT 1;
            }
        }
  
   //walking animation
   IF(my.FRAMES_TO_PLAY == WALKING)
       {
        my.FRAME = FRM_MANCER_WALK_START;
        WHILE(my.FRAMES_TO_PLAY == WALKING && my.HEALTH >= 1)
           {
            my.FRAME +=FRM_MANCER_WALK_ANIMSPEED*TIME;
            IF(my.FRAME > FRM_MANCER_WALK_END) 
                 {
                 my.NEXT_FRAME = FRM_MANCER_WALK_START;
                 }
            ELSE
                 {
                 my.NEXT_FRAME = 0;
                 }
            IF(my.FRAME >= FRM_MANCER_WALK_END + 1)
                 {
                 my.FRAME = FRM_MANCER_WALK_START;
                 }
            WAIT 1;
            }
        }
    
    //running animation
    IF(my.FRAMES_TO_PLAY == RUNNING)
       {
        my.FRAME = FRM_MANCER_RUN_START;
        WHILE(my.FRAMES_TO_PLAY == RUNNING && my.HEALTH >= 1)
           {
            my.FRAME +=FRM_MANCER_RUN_ANIMSPEED*TIME;
            IF(my.FRAME > FRM_MANCER_RUN_END) 
                 {
                 my.NEXT_FRAME = FRM_MANCER_RUN_START;
                 }
            ELSE
                 {
                 my.NEXT_FRAME = 0;
                 }
            IF(my.FRAME >= FRM_MANCER_RUN_END + 1)
                 {
                 my.FRAME = FRM_MANCER_RUN_START;
                 }
            WAIT 1;
            }
        }
       
       //attack high animation
       IF(my.FRAMES_TO_PLAY == ATTACKINGHIGH && my.HEALTH >= 1 && my.FLAG3 == 0)
       {
        ent_vertex(temp,MANCER_WEAPONFLASH_VERTEX);
        effect(particle_smoke2,5*time,temp.X,nullvector);//smoke trail
        ent_vertex(temp,MANCER_WEAPONFLASH_VERTEX);
        create <rocket.mdl>,temp,mancer_bullet_action;
        my.FRAME = FRM_MANCER_ATTACKHIGH_START;
        WHILE(my.FRAMES_TO_PLAY == ATTACKINGHIGH && my.HEALTH >= 1 && my.FLAG3 == 0)
           {
            my.FRAME +=FRM_MANCER_ATTACKHIGH_ANIMSPEED*TIME;
            IF(my.FRAME > FRM_MANCER_ATTACKHIGH_END) 
                 {
                 my.NEXT_FRAME = FRM_MANCER_ATTACKHIGH_START;
                 }
            ELSE
                 {
                 my.NEXT_FRAME = 0;
                 }
            IF(my.FRAME >= FRM_MANCER_ATTACKHIGH_END + 1)
                 {
                 my.FRAME = FRM_MANCER_ATTACKHIGH_START;        
		     ent_vertex(temp,MANCER_WEAPONFLASH_VERTEX);
                 effect(particle_smoke2,5*time,temp.X,nullvector);//smoke trail
                 ent_vertex(temp,MANCER_WEAPONFLASH_VERTEX);
                 create <rocket.mdl>,temp,mancer_bullet_action;
                 mancer_wait_attack();
                 }
            WAIT 1;
            }
         }

       //attack low animation
       IF(my.FRAMES_TO_PLAY == ATTACKINGLOW && my.HEALTH >= 1 && my.FLAG3 == 0)
       {
        ent_vertex(temp,MANCER_WEAPONFLASH_VERTEX);
        create <rocket.mdl>,temp,mancer_bullet_action;
	  ent_vertex(temp,MANCER_WEAPONFLASH_VERTEX);
        effect(particle_smoke2,5*time,temp.X,nullvector);//smoke trail
        my.FRAME = FRM_MANCER_ATTACKLOW_START;
        WHILE(my.FRAMES_TO_PLAY == ATTACKINGLOW && my.HEALTH >= 1 && my.FLAG3 == 0)
           {
            my.FRAME +=FRM_MANCER_ATTACKLOW_ANIMSPEED*TIME;
            IF(my.FRAME > FRM_MANCER_ATTACKLOW_END) 
                 {
                 my.NEXT_FRAME = FRM_MANCER_ATTACKLOW_START;
                 }
            ELSE
                 {
                 my.NEXT_FRAME = 0;
                 }
            IF(my.FRAME >= FRM_MANCER_ATTACKLOW_END + 1)
                 {
                 my.FRAME = FRM_MANCER_ATTACKLOW_START;        
                 ent_vertex(temp,MANCER_WEAPONFLASH_VERTEX);
                 effect(particle_smoke2,5*time,temp.X,nullvector);//smoke trail
                 ent_vertex(temp,MANCER_WEAPONFLASH_VERTEX);
                 create <rocket.mdl>,temp,mancer_bullet_action;
                 mancer_wait_attack(); 
		     }
            WAIT 1;
            }
        }

       //attack medium animation
       IF(my.FRAMES_TO_PLAY == ATTACKINGMEDIUM && my.HEALTH >= 1 && my.FLAG3 == 0)
       {
        ent_vertex(temp,MANCER_WEAPONFLASH_VERTEX);
        effect(particle_smoke2,5*time,temp.X,nullvector);//smoke trail
        ent_vertex(temp,MANCER_WEAPONFLASH_VERTEX);
        create <rocket.mdl>,temp,mancer_bullet_action;
        my.FRAME = FRM_MANCER_ATTACKMEDIUM_START;
        WHILE(my.FRAMES_TO_PLAY == ATTACKINGMEDIUM && my.HEALTH >= 1 && my.FLAG3 == 0)
           {
            my.FRAME +=FRM_MANCER_ATTACKMEDIUM_ANIMSPEED*TIME;
            IF(my.FRAME > FRM_MANCER_ATTACKMEDIUM_END) 
                 {
                 my.NEXT_FRAME = FRM_MANCER_ATTACKMEDIUM_START;
                 }
            ELSE
                 {
                 my.NEXT_FRAME = 0;
                 }
            IF(my.FRAME >= FRM_MANCER_ATTACKMEDIUM_END + 1)
                 {
                 my.FRAME = FRM_MANCER_ATTACKMEDIUM_START;        
                 ent_vertex(temp,MANCER_WEAPONFLASH_VERTEX);
                 create <rocket.mdl>,temp,mancer_bullet_action;
                 ent_vertex(temp,MANCER_WEAPONFLASH_VERTEX);                
                 effect(particle_smoke2,5*time,temp.X,nullvector);//smoke trail
                 //wait some time
                 my.FLAG3 = 1;
                 mancer_wait_attack(); 
		     }
            WAIT 1;
            }
        }

   //weak pain animation  
   IF(my.FRAMES_TO_PLAY == PAININGWEAK && my.HEALTH >= 1)
       {
        my.FRAME = FRM_MANCER_PAINWEAK_START;
        WHILE(my.FRAME <= FRM_MANCER_PAINWEAK_END && my.HEALTH >= 1)
           {
            my.FRAME +=FRM_MANCER_PAINWEAK_ANIMSPEED*TIME;
            my.NEXT_FRAME = 0;
            WAIT 1;
            }
        IF(my.FRAMES_TO_PLAY != DYINGWEAK || my.FRAMES_TO_PLAY != DYINGSTRONG) { my.FRAMES_TO_PLAY = my.SKILL48;}
        my.PAIN_FRAMES_PLAYING = 0;
        }
     
     //strong pain animation  
     IF(my.FRAMES_TO_PLAY == PAININGSTRONG && my.HEALTH >= 1)
       {
        my.FRAME = FRM_MANCER_PAINSTRONG_START;
        WHILE(my.FRAME <= FRM_MANCER_PAINSTRONG_END && my.HEALTH >= 1)
           {
            my.FRAME +=FRM_MANCER_PAINSTRONG_ANIMSPEED*TIME;
            my.NEXT_FRAME = 0;
            WAIT 1;
            }
        IF(my.FRAMES_TO_PLAY != DYINGWEAK || my.FRAMES_TO_PLAY != DYINGSTRONG) { my.FRAMES_TO_PLAY = my.SKILL48;}
        my.PAIN_FRAMES_PLAYING = 0;
        }

    WAIT 1;//for the big while loop
    }
}
//------------
 

//play mancer's death animation
//-----------------------------------------------------
function mancer_death_animation()
{
//weak die animation
IF(my.FRAMES_TO_PLAY == DYINGWEAK)
       {
        my.FRAME = FRM_MANCER_DIEWEAK_START;
        WHILE(my.FRAME <= FRM_MANCER_DIEWEAK_END)
           {
            my.FRAME +=FRM_MANCER_DIEWEAK_ANIMSPEED*TIME;
            my.NEXT_FRAME = 0;
            WAIT 1;
           }
        SONAR ME,500;
        CREATE <blood.bmp>,TARGET,mancer_blood_pool;
        WAITT 300;
        REMOVE ME; 
        RETURN;
        }

//strong die animation
IF(my.FRAMES_TO_PLAY == DYINGSTRONG)
       {
        my.FRAME = FRM_MANCER_DIESTRONG_START;
        WHILE(my.FRAME <= FRM_MANCER_DIESTRONG_END)
           {
            my.FRAME +=FRM_MANCER_DIESTRONG_ANIMSPEED*TIME;
            my.NEXT_FRAME = 0;
            WAIT 1;
           }
        SONAR ME,500;
        CREATE <blood.bmp>,TARGET,mancer_blood_pool;
        WAITT 300;
        REMOVE ME; 
        RETURN;
        }
}
//------------


//create blood pool below mancer
//------------------------------------------------------
function mancer_blood_pool()
{
vec_scale(my.SCALE_X,1);
my.LIGHTGREEN = 150;
my.LIGHTRANGE = 10;
my.LIGHT = ON;
my.FLARE = ON;
my.PASSABLE = ON;
my.ORIENTED = ON;
vec_to_angle(my.PAN,NORMAL);	// rotate to target normal
WHILE(my.SCALE_X <= 2)
   {
   my.SCALE_X += 0.008*TIME;
   my.SCALE_Y += 0.008*TIME;
   WAIT 1;
   }
WAITT 200;
REMOVE ME;
}
//------------


//mancer's bullet's event action
//------------------------------------------------------
function mancer_bullet_event()
{
IF(  EVENT_TYPE == EVENT_BLOCK
   ||EVENT_TYPE == EVENT_ENTITY
   ||EVENT_TYPE == EVENT_IMPACT)
      {
      mancer_bullet_nullify();  
      EXCLUSIVE_ENTITY;  
      IF(you == player && godmode == 0) { 
                          IF(player_mode == HUMANMODE) { temp = 7;}
                          ELSE { temp = 3; } 
 			        IF(armour >= 1) { armour -= 6;armour = max(armour,0);temp = 2;}
                          player.HEALTH -= temp;
  				  player_damage_indicate();
				  WAITT 64;
                        }
      REMOVE ME;
      RETURN;
      }
}
//-----------


//----------------------------------------------------
bmap redcircle_map = <redcirc2.pcx>;
PANEL red_circle_panel
{
	pos_x = 0;//270
	pos_y = 0;//190
      layer = 100;
	bmap = redcircle_map;
	FLAGS = REFRESH,D3D,OVERLAY,TRANSPARENT;
}
//---------

//----------------------------------------------------
function player_damage_indicate()
{
IF(red_circle_blinking == 1) { RETURN;}
red_circle_blinking = 1;
red_circle_panel.ALPHA = 20;
red_circle_panel.VISIBLE = ON;
WHILE(red_circle_panel.ALPHA <= 40)
    {
     red_circle_panel.ALPHA += 2;
     WAITT 1;
    }
WHILE(red_circle_panel.ALPHA >= 20)
    {
     red_circle_panel.ALPHA -= 2;
     WAITT 1;
    }

red_circle_panel.VISIBLE = OFF;

red_circle_blinking = 0;
}
//----------


//remove's mancer's bullet entity
//-----------------------------------------------------
function mancer_bullet_nullify()
{
my.EVENT = NULL;
my.ENABLE_BLOCK = OFF;
my.ENABLE_IMPACT = OFF;
my.ENABLE_ENTITY = OFF;
my.PASSABLE = ON;
my.PUSH = -100000;
my.INVISIBLE = ON;
my.LIGHTRANGE = 0;
}
//----------


//mancer's gun muzzle flash
//-----------------------------------------------------
function mancer_muzzle_flash()
{
vec_scale(my.SCALE_X,0.2);
my.FACING = ON;
my.PASSABLE = ON;
my.NOFILTER = ON;
my.FLARE = ON;
my.LIGHTRED = 160;
my.LIGHTGREEN = 100;
my.LIGHTBLUE = 20;
my.LIGHTRANGE = 60;
my.LIGHT = ON;
my.BRIGHT = ON;
WAITT 2;
REMOVE ME;
}
//----------


//let mancer's bullet travel
//according to difficulty level
//------------------------------------------------------  
function mancer_bullet_action()
{
//store creator
my.ENTITY1 = YOU;

//play bullet sound
play_entsound you,snd_mancer_bullet,600;

//store vertex coordinates
vec_set(my.SKILL1,temp.X);

//create muzzle flash at mancer's gun muzzle
CREATE <gflash3.pcx>,temp,mancer_muzzle_flash;

YOU = my.ENTITY1;

//first increment the mancer's bullet hit counter
YOUR.BULLET_HIT_COUNTER += 1;
IF(YOUR.BULLET_HIT_COUNTER == 6)
    {
    YOUR.BULLET_HIT_COUNTER = 1;
    }

//now set target according to difficulty level
//least difficult
IF(random(10) >= 5) { temp = -1;}
ELSE { temp = 1;}

IF(difficulty == 1)
  {
  my.SKILL4 = player.X + temp*(30 + random(20));
  my.SKILL5 = player.Y + temp*(30 + random(20));
  my.SKILL6 = player.Z + 5  + random(10);
  IF(YOUR.BULLET_HIT_COUNTER == 5) { vec_set(my.SKILL4,player.X);}
  }
IF(difficulty == 2)
  {
  my.SKILL4 = player.X + temp*(30 + random(20));
  my.SKILL5 = player.Y + temp*(30 + random(20));
  my.SKILL6 = player.Z + 5  + random(10);
  IF(YOUR.BULLET_HIT_COUNTER == 4 || YOUR.BULLET_HIT_COUNTER == 5 ) {vec_set(my.SKILL4,player.X);}
  }
IF(difficulty == 3)
  {
  my.SKILL4 = player.X + temp*(30 + random(20));
  my.SKILL5 = player.Y + temp*(30 + random(20));
  my.SKILL6 = player.Z + 5  + random(10);
  IF(YOUR.BULLET_HIT_COUNTER == 3 || YOUR.BULLET_HIT_COUNTER == 4 || YOUR.BULLET_HIT_COUNTER == 5  ) {vec_set(my.SKILL4,player.X);}
  }

 //now calculate its direction
 my.SKILL7 = my.SKILL4 - my.SKILL1;
 my.SKILL8 = my.SKILL5 - my.SKILL2;
 my.SKILL9 = my.SKILL6 - my.SKILL3;
 
 //now normalize bullet speed vector
 vec_normalize(my.SKILL7,MANCER_BULLET_SPEED);

 //now rotate the bullet
 vec_to_angle(my.PAN,my.SKILL7);
 
 //apply special effects to bullet
 my.SCALE_X *= 0.7;
 my.SCALE_Y *= 0.2;
 my.SCALE_Z *= 0.2;
 my.LIGHTRED = 160;
 my.LIGHTGREEN = 100;
 my.LIGHTBLUE = 20;
 my.LIGHTRANGE = 10;
 my.LIGHT = ON;
 my.BRIGHT = ON;
 my.AMBIENT = 75;
 
 //let the bullet be able to collide
 my.ENABLE_BLOCK = ON;
 my.ENABLE_ENTITY = ON;
 my.ENABLE_IMPACT = ON;

 //set event action
 my.EVENT = mancer_bullet_event;

 //lifecounter
 my.SKILl10 = 0; 

 //now move the bullet
 WHILE(my.SKILL10 != 200)
  {
  my.SKILl10 += 1;
  vec_set(mancer_bullet_vector,my.SKILL7);  
  vec_scale(mancer_bullet_vector,TIME);
  //MOVE_MODE = IGNORE_YOU;
  ent_move(nullskill,mancer_bullet_vector);
  WAIT 1;
  }

//remove bullet
REMOVE ME;
}
//-----------
 

//--------------------------------------------
function mancer_blood_fade()
{
my.alpha -= time * 2;  // stay with framerate
if(my.alpha < 0) { my.lifespan = 0;}
}
//-----------

 
//--------------------------------------------
function mancer_vec_blood(&vec)
{
vec[0] = random(8) - 4;
vec[1] = random(8) - 4;
vec[2] = random(20) - 13;
}
//----------



//--------------------------------------------
function mancer_particle_blood()
{
mancer_vec_blood(temp);
vec_set(my.vel_x,temp); //set the velocity
my.lifespan = 30;
my.flare = on;	//flare transparency
my.move = on;	//move according to vel_x, vel_y, and vel_z
my.bmap = bmp_mancer_blood;
//my.beam = on;
//my.streak = on;
my.gravity = 2;
my.alpha = 30;
my.size = 1;
my.function = mancer_blood_fade;	//fade out near end of life
}
//-----------


//-------------------------------------------
function mancer_blood_spurt()
{
my.skill47 = INT(random(800));	
ent_vertex(temp,my.skill47);
effect(mancer_particle_blood,2+5*time,temp.X,nullvector);
}
//----------

//-------------------------------------------
function mancer_blood_drop()
{
effect(mancer_particle_blood,1+time,my.X,nullvector);
}
//----------

//-----------FUTURE WORK--------------------------------
//trigger based mancers
ACTION mancer
{
my.PASSABLE = ON;
}







