//------PANELS----------------------------------------
bmap endscreen_map = <endscreen.pcx>;
PANEL enscreen_panel
{
pos_x = 0;
pos_y = 0;
bmap endscreen_map;
layer = 200000;
flags = refresh,d3d;
}
//---------


//-----------Defines----------------------------------

//frames values
DEFINE FRM_pipkorg_STAND_START,1;
DEFINE FRM_pipkorg_STAND_END,21;
DEFINE FRM_pipkorg_WALK_START,22;
DEFINE FRM_pipkorg_WALK_END,51;
DEFINE FRM_pipkorg_RUN_START,22;
DEFINE FRM_pipkorg_RUN_END,51;
DEFINE FRM_pipkorg_ATTACKHIGH_START,149;
DEFINE FRM_pipkorg_ATTACKHIGH_END,155;
DEFINE FRM_pipkorg_ATTACKMEDIUM_START,52;
DEFINE FRM_pipkorg_ATTACKMEDIUM_END,61;
DEFINE FRM_pipkorg_ATTACKLOW_START,189;
DEFINE FRM_pipkorg_ATTACKLOW_END,195;
DEFINE FRM_pipkorg_PAINWEAK_START,62;
DEFINE FRM_pipkorg_PAINWEAK_END,78;
DEFINE FRM_pipkorg_PAINSTRONG_START,79;
DEFINE FRM_pipkorg_PAINSTRONG_END,118;
DEFINE FRM_pipkorg_DIEWEAK_START,119;
DEFINE FRM_pipkorg_DIEWEAK_END,129;
DEFINE FRM_pipkorg_DIESTRONG_START,158;
DEFINE FRM_pipkorg_DIESTRONG_END,170;

//animation speed values
DEFINE FRM_pipkorg_STAND_ANIMSPEED,0.1;
DEFINE FRM_pipkorg_WALK_ANIMSPEED,0.8;
DEFINE FRM_pipkorg_RUN_ANIMSPEED,2;
DEFINE FRM_pipkorg_ATTACKHIGH_ANIMSPEED,0.5;
DEFINE FRM_pipkorg_ATTACKLOW_ANIMSPEED,0.5;
DEFINE FRM_pipkorg_ATTACKMEDIUM_ANIMSPEED,0.3;
DEFINE FRM_pipkorg_PAINWEAK_ANIMSPEED,1.2;
DEFINE FRM_pipkorg_PAINSTRONG_ANIMSPEED,1.2;
DEFINE FRM_pipkorg_DIEWEAK_ANIMSPEED,1.2;
DEFINE FRM_pipkorg_DIESTRONG_ANIMSPEED,2;

//miscellaneous defines
DEFINE pipkorg_START_HEALTH,2000;
DEFINE pipkorg_WALK_DIST,0.3;
DEFINE pipkorg_RUN_DIST,2;
DEFINE pipkorg_SCANCONE_RADIUS,1000;
DEFINE pipkorg_SCANCONE_PAN,260;
DEFINE pipkorg_SCANCONE_TILT,180;
DEFINE pipkorg_BULLET_SPEED,40;
DEFINE pipkorg_BULLET_DAMAGE,10;
DEFINE pipkorg_PAIN_AGAIN_INTERVAL,32;
DEFINE pipkorg_PATROL_WAIT_INTERVAL,48;
DEFINE pipkorg_WEAPONFLASH_VERTEX,103;

//--------


//----------Vars--------------------------------------
var pipkorg_bullet_vector;
//--------


//----------Sounds------------------------------------
SOUND snd_pipkorg_growl1,pipkorg1.wav>;
SOUND snd_pipkorg_bullet,<pipfire1.wav>;
SOUND snd_pipkorg_pain1,<pippain1.wav>;
SOUND snd_pipkorg_bodygib1,<bodygib.wav>;
//--------


//----------Images------------------------------------
//bmap bmp_pipkorg_blood = <gpart1.pcx>;
//bmap bmp_pipkorg_blood = <sparkle.bmp>;
//bmap bmp_pipkorg_blood = <blood.bmp>;
bmap bmp_pipkorg_blood = <blood.pcx>;
//--------


//The main pipkorg action
//----------------------------------------------------
function pipkorg_main()
{
WHILE(player == NULL) { WAIT 1;}
//initialise parameters for pipkorg
pipkorg_initialise();

//apply gravity to pipkorg
entity_apply_gravity();

//play animation frames of pipkorg
pipkorg_play_animations();

//test action anly
//macer_random_destinations();

//keep moving pipkorg to its destination
pipkorg_move_to_target();

//flip pipkorg in between
//pipkorg_tilt_randomly();

//pipkorg play sound randomly
pipkorg_sounds_random();

//makes pipkorg invisible
pipkorg_invisible_random();

//makes pipkorg brighter in robo mode
pipkorg_brighter_robomode();
}
//-----------

//----------------------------------
function pipkorg_brighter_robomode()
{
WHILE(my.HEALTH >= 1 )
   {
    IF(player_mode == ROBOMODE) { my.AMBIENT = 100;my.BRIGHT = ON;}
    ELSE { my.AMBIENT = 0;my.BRIGHT = OFF;}
    WAITT 8;//longer waitt for better fps
   }
}
//--------
    
  
//----------------------------------
function pipkorg_invisible_random()
{
WHILE(my.HEALTH >= 1)
   {
    my.ALPHA = 100; 
    temp = 200 + random(100);
    WAITT temp;
    my.LIGHT = ON;
    my.LIGHTGREEN = 150;
    my.LIGHTRANGE = 20;
    my.TRANSPARENT = ON;
      WHILE(my.ALPHA >= 15)
         { 
          my.ALPHA -= 5*TIME;
          WAIT 1;
         }
    my.LIGHTRANGE = 0;
    my.LIGHTGREEN = 0;
    my.ALPHA = 15;
    temp = 20 + random(20);
    WAITT temp;
    
    my.LIGHT = ON;
    my.LIGHTGREEN = 150;
    my.LIGHTRANGE = 20;

      WHILE(my.ALPHA <= 95)
         { 
          my.ALPHA += 5*TIME;
          WAIT 1;
         }     
    my.LIGHT = OFF;
    my.LIGHTGREEN = 0;
    my.LIGHTRANGE = 0;

    }
}
//---------- 


//---------------------------------------------------
function pipkorg_sounds_random()
{
WHILE(my.HEALTH >= 1)
  {
   PLAY_ENTSOUND ME,snd_pipkorg_growl1,900;
   temp = 50 + random(60);
   WAITT temp;
  }
}
//----------

//----------------------------------------------------
function pipkorg_tilt_randomly()
{
WHILE(my.HEALTH >= 1)
  {
   my.TILT = 0;
   temp = 100 + random(100);
   WAIT temp;
  //tilt only when running
  WHILE(my.FRAMES_TO_PLAY != RUNNING) { WAIT 1;}
  WHILE(my.TILT >= -359 && my.HEALTH >= 1 && my.FRAMES_TO_PLAY == RUNNING)
       {
       my.TILT -= 40*TIME;
       WAIT 1;
      }
   IF(my.HEALTH <= 0) { RETURN ;}
  }
}
//----------

 
//this function moves the pipkorg
//to its destination continuosly
//----------------------------------------------------
function pipkorg_move_to_target()
{
WHILE(my.HEALTH >= 1)
  {
  //calculate direction vector to destination
  temp.X = my.TARGET_X - my.X;
  temp.Y = my.TARGET_Y - my.Y;
  temp.Z = 0;
 
  //decide speed according to animation type
  IF(my.FRAMES_TO_PLAY == WALKING)
    {
    vec_normalize(temp,pipkorg_WALK_DIST);
    }
  IF(my.FRAMES_TO_PLAY == RUNNING)
    {
    vec_normalize(temp,pipkorg_RUN_DIST);
    }
  IF(my.FRAMES_TO_PLAY != WALKING && my.FRAMES_TO_PLAY != RUNNING)
    {
    vec_normalize(temp,0);
    }   

  //time correct the speed
  vec_scale(temp,TIME);

  //now move the pipkorg
  move_mode = GLIDE+ignore_passable+ignore_passents;
  result = ent_move(nullskill,temp);
 
  WAIT 1;
  }
}
//-------------


//----------------------------------------------------
function macer_random_destinations()
{
WHILE(1)
  {
  vec_set(my.TARGET_X,player.X);
  WAIT 1;
  }
}
//--------


//pipkorg that patrols on a path
//branch to pipkorg_main function
//----------------------------------------------------
ACTION pipkorg_patrol
{
//patrol
my.FLAG1 = ON;
pipkorg_main();
}
//-----------


//pipkorg that stands still 
//branch to pipkorg_main function
//----------------------------------------------------
ACTION pipkorg_stand
{
//don't patrol
my.FLAG1 = OFF;
pipkorg_main();
}
//-----------


//pipkorg's event action
//------------------------------------------------------
function pipkorg_event_action()
{

//shot by player
IF(EVENT_TYPE == EVENT_SHOOT && indicator == _GUNFIRE)
  {
  //if dead state then gib
  IF(my.HEALTH <= 0) { my.ENABLE_SHOOT = OFF;pipkorg_gib();RETURN;} 

  //play pain sound
  play_entsound me,snd_pipkorg_pain1,800;
  //pipkorg's green blood
  pipkorg_blood_spurt();  

  //reset indicator to avoid conflicts
  indicator = -10; 
  //first calculate damage and reduce health
  damage = 5 + random(10);
  my.HEALTH -= damage;
  
  //kill pipkorg 
  IF(my.HEALTH <= 0) { 
                     //if below 0 then nullify pipkorg  
                     pipkorg_nullify();
                     //if health very low,then gib
                     //else decide between weak and
                     //strong die
                     pipkorg_gib();
                     RETURN;
                     }

  //if already playing pain frames
  IF(my.PAIN_FRAMES_PLAYING == 1) { RETURN ;}
  //store previous animation that was playing
  my.SKILL48 = my.FRAMES_TO_PLAY;
  my.PAIN_FRAMES_PLAYING = 1;
  IF(damage <= 10) { my.FRAMES_TO_PLAY = PAININGWEAK;}
  ELSE { my.FRAMES_TO_PLAY = PAININGSTRONG;}
 
  //attack player
  IF(my.ATTACKED_PLAYER_ONCE == 0) { 
 						 my.ATTACKED_PLAYER_ONCE = 1;
                                     pipkorg_run_and_attack();
                                   } 

  RETURN;
  }

//if player detected by scanning
IF(EVENT_TYPE == EVENT_DETECT && YOU == player && indicator == 100)
  {
   indicator = 0;
   my.ATTACKED_PLAYER_ONCE = 1;
   pipkorg_run_and_attack();
   RETURN;
  }

//if grenade explodes
IF(EVENT_TYPE == EVENT_SCAN && indicator == _EXPLODE)
  {
  //indicator = 0;
  my.HEALTH -= ((range - RESULT)/range)*range;

  //play pain sound
  play_entsound me,snd_pipkorg_pain1,800;
  //pipkorg's green blood
  pipkorg_blood_spurt();  

  //reset indicator to avoid conflicts
  indicator = -10; 
  
  //kill pipkorg 
  IF(my.HEALTH <= 0) { 
                     //if below 0 then nullify pipkorg  
                     pipkorg_nullify();
                     //if health very low,then gib
                     //else decide between weak and
                     //strong die
                     IF(my.HEALTH <= -10) { pipkorg_gib();RETURN;}
                     IF(my.HEALTH <= -5) { my.FRAMES_TO_PLAY = DYINGSTRONG;pipkorg_death_animation();}
                     ELSE { my.FRAMES_TO_PLAY = DYINGWEAK;pipkorg_death_animation();}
                     RETURN;
                     }

  //if already playing pain frames
  IF(my.PAIN_FRAMES_PLAYING == 1) { RETURN ;}
  //store previous animation that was playing
  my.SKILL48 = my.FRAMES_TO_PLAY;
  my.PAIN_FRAMES_PLAYING = 1;
  IF(damage <= 10) { my.FRAMES_TO_PLAY = PAININGWEAK;}
  ELSE { my.FRAMES_TO_PLAY = PAININGSTRONG;}
 
  //attack player
  IF(my.ATTACKED_PLAYER_ONCE == 0) { 
 						 my.ATTACKED_PLAYER_ONCE = 1;
                                     pipkorg_run_and_attack();
                                   } 



  RETURN; 
  }
}
//-----------
 

//stop pipkorg's movement and make it
//a dead as a table type object
//-------------------------------------------------------------------
function pipkorg_nullify()
{
my.ROLL = 0;
//my.PASSABLE = ON;
//my.EVENT = NULL;
//my.ENABLE_SCAN = OFF;
my.ENABLE_DETECT = OFF;
my.ENABLE_ENTITY = OFF;
my.ENABLE_IMPACT = OFF;
//my.ENABLE_SHOOT = OFF;//set after its completely gibbed
WAIT 1;
}
//-------------


//gib pipkorg's body
//-------------------------------------------------------------------
function pipkorg_gib()
{
play_entsound me,snd_pipkorg_bodygib1,1000;
my.INVISIBLE = ON;
WAIT 1;
my.SKILL1 = 0;
WHILE(my.SKILL1 != 6)
  {
  IF(random(1) > 0.5) { CREATE <mancgib1.mdl>,my.X,pipkorg_gib_fly;}
  ELSE  { CREATE <mancgib2.mdl>,my.X,pipkorg_gib_fly;}
  my.SKILL1 += 1;
  WAIT 1; 
  }
WAIT 3;
REMOVE ME;
WAITT 16;

STOP_SOUND music_handle;
enscreen_panel.VISIBLE = ON;
ON_ESC = NULL;
FREEZE_MODE = 1;
WHILE(KEY_ENTER != 1) { WAIT 1;}
enscreen_panel.VISIBLE = OFF;
main_branch();
}
//----------


//pipkorg's gib event
//-----------------------------------------------------
function pipkorg_gib_event()
{
IF(EVENT_TYPE == EVENT_BLOCK)
    {
    pipkorg_gib_remove();
    RETURN;
    }
}
//-----------   

//make pipkorg's gib fly
//------------------------------------------------------
function pipkorg_gib_fly()
{
/*
//make it collidable with walls
my.ENABLE_BLOCK = ON;
my.FAT = ON;
my.NARROW = ON;
my.MIN_X *= 0.1;
my.MIN_Y *= 0.1;
my.MIN_Z *= 0.1;
my.MAX_X *= 0.1;
my.MAX_Y *= 0.1;
my.MAX_Z *= 0.1;
*/
my.PASSABLE = ON;

//scale the gib
temp = 0.3 + random(0.2);
vec_scale(my.SCALE_X,temp);

//set direction of gib
temp = 1;
IF(random(10) >= 5) {temp = -1;}
my.SKILL1 = temp*3;
temp = 1;
IF(random(10) >= 5) {temp = -1;}
my.SKILL2 = temp*3;
my.SKILL3 = 12 + random(6) ;

my.EVENT = pipkorg_gib_event;
//counter to remove gib
my.SKILL4 = 0;
WHILE(my.SKILL4 != 200)
  {
  //decrease height
  my.SKILL3 -= 3*TIME;
  vec_set(temp.X,my.SKILL1);
  vec_scale(temp.X,TIME);
  MOVE ME,NULLSKILL,temp;
  IF(my.SKILL4 % 4 == 0) { pipkorg_blood_drop(); }
  //IF(my.SKILl4 % 15 == 0) { CREATE <blood.>,my.X,pipkorg_gib_blood;}
  my.SKILL4 += 1;
  my.TILT += random(10*TIME);
  my.ROLL -= random(20*TIME);
  WAIT 1;
  }
WAIT 1;
REMOVE ME;
}
//-------------


//remove pipkorg's gib
//------------------------------------------------------
function pipkorg_gib_remove()
{
my.EVENT = NULL;
EXCLUSIVE_ENTITY;
WAIT 1;
WHILE(my.SKILL4 != 200)
   {
    my.SKILL4 += 1;
    WAIT 1;
   }
my.TRANSPARENT = ON;
my.ALPHA = 100;
WHILE(my.ALPHA >= 0)
  {
  my.ALPHA -= 5*TIME;
  WAIT 1;
  }
}
//-------------


//pipkorg's blood Q3 style
//------------------------------------------------------
function pipkorg_gib_blood()
{
my.PASSABLE = ON;
my.OVERLAY = ON;
my.FLARE = ON;
vec_scale(my.SCALE_X,0.07);
my.LIGHTGREEN = 100;
my.LIGHTRANGE = 10;
WHILE(my.SKILL1 != 100)
   {
    my.Z -= 3*TIME;
    my.SCALE_Y += 0.02*TIME;
    my.SCALE_X += 0.006*TIME;
    WAIT 1;
   }
REMOVE ME;
}
//-----------


//------------------------------------------------------
function pipkorg_pain_wait()
{
my.SKILL48 = my.FRAMES_TO_PLAY;
WAITT 24;
my.FRAMES_TO_PLAY = my.SKILL48;
}
//------------

 
//run and attack player
//------------------------------------------------------
function pipkorg_run_and_attack()
{
my.AI_MODE = RUN_AND_ATTACK;
WAIT 1;
WHILE(my.AI_MODE == RUN_AND_ATTACK && my.HEALTH >= 1)
   {
   WHILE(my.PAIN_FRAMES_PLAYING == 1) 
      {
       WAIT 1;
      }
   IF(my.HEALTH <= 0) { RETURN; }   
  
   vec_set(temp.X,player.X);
   vec_sub(temp.X,my.X);
   vec_to_angle(temp_pan,temp.X);
   my.PAN = temp_pan.PAN;
   SHOOT my.POS,player.POS;
   IF(YOU == player)
     {      
      my.FRAMES_TO_PLAY = ATTACKINGMEDIUM;
      IF(player.Z > my.Z + 100) {  my.FRAMES_TO_PLAY = ATTACKINGHIGH;}
      IF(player.Z < my.Z - 20) {  my.FRAMES_TO_PLAY = ATTACKINGLOW;}
      }
    ELSE
     {
      my.FRAMES_TO_PLAY = RUNNING;
      pipkorg_patrol_and_scan(); 
      pipkorg_search_player_sometime();
     }
    WAIT 1;
   }
}
//--------


//search for player for some time
//if not found then again start patrolling
//-----------------------------------------------------
function pipkorg_search_player_sometime()
{
my.SEARCH_PLAYER_COUNTER = 0;
WHILE(my.AI_MODE == PATROL_AND_SCAN && my.HEALTH >= 1)
   {
   my.SEARCH_PLAYER_COUNTER += 1;
   IF(my.SEARCH_PLAYER_COUNTER == 400)
     {
      BREAK;
     }
    WAITT 1;
   }
IF(my.HEALTH <= 0) { RETURN;}
my.ATTACKED_PLAYER_ONCE = 0;
my.RANDOM_STAND_WALK_WAIT = 0;
}
//------------
        

//to initialise pipkorg
//------------------------------------------------------
function pipkorg_initialise()
{
//set some misc flags
my.FAT = ON;
my.NARROW = ON;
my.SHADOW = ON;

//set enable flags
my.ENABLE_SHOOT = ON;
my.ENABLE_SCAN = ON;
my.ENABLE_DETECT = ON;

vec_scale(my.SCALE_X,1.2);
my.HEALTH = pipkorg_START_HEALTH;

//find a path in a full sphere 
temp.PAN = 360;
temp.TILT = 180;
temp.Z = 1000;
result = scan_path(my.X,temp.X);
IF(result == 0) { RETURN ;}
ent_waypoint(my.TARGET_X,1);

//patrol or stand and scan for player
IF(my.FLAG1 == ON) {
                    my.FRAMES_TO_PLAY = WALKING;
                    pipkorg_patrol_and_scan();
                    }

ELSE                {
                    my.FRAMES_TO_PLAY = STANDING;
                    pipkorg_stand_and_scan();
                    }

//set event action
my.EVENT = pipkorg_event_action;

}
//-----------
 
//make pipkorg to patrol
//-----------------------------------------------------
function pipkorg_patrol_and_scan()
{
my.AI_MODE = PATROL_AND_SCAN;
WAIT 1;
WHILE(my.AI_MODE == PATROL_AND_SCAN && my.HEALTH >= 1)
  {
  
 //make pipkorg stand or walk randomly whilst not attacked player once
  IF(my.ATTACKED_PLAYER_ONCE == 0 && my.RANDOM_STAND_WALK_WAIT == 0)
    {
    pipkorg_walkstand_counter();
    //more probability of walking 80 : 20 odds
    temp = random(100);
    IF(temp<=80)
       {
        my.FRAMES_TO_PLAY = WALKING;
       }
    ELSE
       {
        my.FRAMES_TO_PLAY = STANDING;
       }
     }

  //calculate distance to target 
  temp.X = my.TARGET_X - my.X;
  temp.Y = my.TARGET_Y - my.Y;
  temp.Z = 0;

  //rotate to target
  result = vec_to_angle(temp_pan,temp);
  my.PAN = temp_pan.PAN;  

  //if near to waypoint,then find next waypoint 
  IF(result <= 10)
     {
     ent_nextpoint(my.TARGET_X);
     }
  
  //now scan for player
   temp.PAN  = pipkorg_SCANCONE_PAN;
   temp.TILT = pipkorg_SCANCONE_TILT;
   temp.Z    = pipkorg_SCANCONE_RADIUS;
   indicator = 100;
   SCAN my.POS,my.ANGLE,temp;  
   WAIT 1;
  }
}
//---------


//-----------------------------------------------------
function pipkorg_walkstand_counter()
{
WHILE(my.RANDOM_STAND_WALK_WAIT != 200 && my.HEALTH >= 1)
   {
   my.RANDOM_STAND_WALK_WAIT += 1;
   WAIT 1;
   }
my.RANDOM_STAND_WALK_WAIT = 0;
}
//---------


//make pipkorg to stand
//-----------------------------------------------------
function pipkorg_stand_and_scan()
{
my.AI_MODE = STAND_AND_SCAN;
WHILE(my.AI_MODE == STAND_AND_SCAN && my.HEALTH >= 1)
  {
  //scan for player
  
   temp.PAN  = pipkorg_SCANCONE_PAN;
   temp.TILT = pipkorg_SCANCONE_TILT;
   temp.Z    = pipkorg_SCANCONE_RADIUS;
   indicator = 100;
   SCAN my.POS,my.ANGLE,temp;  
   WAIT 1;
  }
}
//---------





//Plays pipkorg's animation according to 
//the value in FRAMES_TO_WALK skill
//-----------------------------------------------------
function pipkorg_play_animations()
{
WHILE(my.HEALTH >= 1)
   {
   //standing animation 
   IF(my.FRAMES_TO_PLAY == STANDING)
       {
        my.FRAME = FRM_pipkorg_STAND_START;
        WHILE(my.FRAMES_TO_PLAY == STANDING && my.HEALTH >= 1)
           {
            my.FRAME +=FRM_pipkorg_STAND_ANIMSPEED*TIME;
            IF(my.FRAME > FRM_pipkorg_STAND_END) 
                 {
                 my.NEXT_FRAME = FRM_pipkorg_STAND_START;
                 }
            ELSE
                 {
                 my.NEXT_FRAME = 0;
                 }
            IF(my.FRAME >= FRM_pipkorg_STAND_END + 1)
                 {
                 my.FRAME = FRM_pipkorg_STAND_START;
                 }
            WAIT 1;
            }
        }
  
   //walking animation
   IF(my.FRAMES_TO_PLAY == WALKING)
       {
        my.FRAME = FRM_pipkorg_WALK_START;
        WHILE(my.FRAMES_TO_PLAY == WALKING && my.HEALTH >= 1)
           {
            my.FRAME +=FRM_pipkorg_WALK_ANIMSPEED*TIME;
            IF(my.FRAME > FRM_pipkorg_WALK_END) 
                 {
                 my.NEXT_FRAME = FRM_pipkorg_WALK_START;
                 }
            ELSE
                 {
                 my.NEXT_FRAME = 0;
                 }
            IF(my.FRAME >= FRM_pipkorg_WALK_END + 1)
                 {
                 my.FRAME = FRM_pipkorg_WALK_START;
                 }
            WAIT 1;
            }
        }
    
    //running animation
    IF(my.FRAMES_TO_PLAY == RUNNING)
       {
        my.FRAME = FRM_pipkorg_RUN_START;
        WHILE(my.FRAMES_TO_PLAY == RUNNING && my.HEALTH >= 1)
           {
            my.FRAME +=FRM_pipkorg_RUN_ANIMSPEED*TIME;
            IF(my.FRAME > FRM_pipkorg_RUN_END) 
                 {
                 my.NEXT_FRAME = FRM_pipkorg_RUN_START;
                 }
            ELSE
                 {
                 my.NEXT_FRAME = 0;
                 }
            IF(my.FRAME >= FRM_pipkorg_RUN_END + 1)
                 {
                 my.FRAME = FRM_pipkorg_RUN_START;
                 }
            WAIT 1;
            }
        }
       
       //attack high animation
       IF(my.FRAMES_TO_PLAY == ATTACKINGHIGH && my.HEALTH >= 1)
       {
        ent_vertex(temp,pipkorg_WEAPONFLASH_VERTEX);
        effect(particle_smoke2,5*time,temp.X,nullvector);//smoke trail
        ent_vertex(temp,pipkorg_WEAPONFLASH_VERTEX);
        create <rocket.mdl>,temp,pipkorg_bullet_action;
        my.FRAME = FRM_pipkorg_ATTACKHIGH_START;
        WHILE(my.FRAMES_TO_PLAY == ATTACKINGHIGH && my.HEALTH >= 1)
           {
            my.FRAME +=FRM_pipkorg_ATTACKHIGH_ANIMSPEED*TIME;
            IF(my.FRAME > FRM_pipkorg_ATTACKHIGH_END) 
                 {
                 my.NEXT_FRAME = FRM_pipkorg_ATTACKHIGH_START;
                 }
            ELSE
                 {
                 my.NEXT_FRAME = 0;
                 }
            IF(my.FRAME >= FRM_pipkorg_ATTACKHIGH_END + 1)
                 {
                 my.FRAME = FRM_pipkorg_ATTACKHIGH_START;        
		     ent_vertex(temp,pipkorg_WEAPONFLASH_VERTEX);
                 effect(particle_smoke2,5*time,temp.X,nullvector);//smoke trail
                 ent_vertex(temp,pipkorg_WEAPONFLASH_VERTEX);
                 create <rocket.mdl>,temp,pipkorg_bullet_action;
                 }
            WAIT 1;
            }
         }

       //attack low animation
       IF(my.FRAMES_TO_PLAY == ATTACKINGLOW && my.HEALTH >= 1)
       {
        ent_vertex(temp,pipkorg_WEAPONFLASH_VERTEX);
        create <rocket.mdl>,temp,pipkorg_bullet_action;
	  ent_vertex(temp,pipkorg_WEAPONFLASH_VERTEX);
        effect(particle_smoke2,5*time,temp.X,nullvector);//smoke trail
        my.FRAME = FRM_pipkorg_ATTACKLOW_START;
        WHILE(my.FRAMES_TO_PLAY == ATTACKINGLOW && my.HEALTH >= 1)
           {
            my.FRAME +=FRM_pipkorg_ATTACKLOW_ANIMSPEED*TIME;
            IF(my.FRAME > FRM_pipkorg_ATTACKLOW_END) 
                 {
                 my.NEXT_FRAME = FRM_pipkorg_ATTACKLOW_START;
                 }
            ELSE
                 {
                 my.NEXT_FRAME = 0;
                 }
            IF(my.FRAME >= FRM_pipkorg_ATTACKLOW_END + 1)
                 {
                 my.FRAME = FRM_pipkorg_ATTACKLOW_START;        
                 ent_vertex(temp,pipkorg_WEAPONFLASH_VERTEX);
                 effect(particle_smoke2,5*time,temp.X,nullvector);//smoke trail
                 ent_vertex(temp,pipkorg_WEAPONFLASH_VERTEX);
                 create <rocket.mdl>,temp,pipkorg_bullet_action;
		     }
            WAIT 1;
            }
        }

       //attack medium animation
       IF(my.FRAMES_TO_PLAY == ATTACKINGMEDIUM && my.HEALTH >= 1)
       {
        ent_vertex(temp,pipkorg_WEAPONFLASH_VERTEX);
        effect(particle_smoke2,5*time,temp.X,nullvector);//smoke trail
        ent_vertex(temp,pipkorg_WEAPONFLASH_VERTEX);
        create <rocket.mdl>,temp,pipkorg_bullet_action;
        my.FRAME = FRM_pipkorg_ATTACKMEDIUM_START;
        WHILE(my.FRAMES_TO_PLAY == ATTACKINGMEDIUM && my.HEALTH >= 1)
           {
            my.FRAME +=FRM_pipkorg_ATTACKMEDIUM_ANIMSPEED*TIME;
            IF(my.FRAME > FRM_pipkorg_ATTACKMEDIUM_END) 
                 {
                 my.NEXT_FRAME = FRM_pipkorg_ATTACKMEDIUM_START;
                 }
            ELSE
                 {
                 my.NEXT_FRAME = 0;
                 }
            IF(my.FRAME >= FRM_pipkorg_ATTACKMEDIUM_END + 1)
                 {
                 my.FRAME = FRM_pipkorg_ATTACKMEDIUM_START;        
                 ent_vertex(temp,pipkorg_WEAPONFLASH_VERTEX);
                 create <rocket.mdl>,temp,pipkorg_bullet_action;
                 ent_vertex(temp,pipkorg_WEAPONFLASH_VERTEX);                
                 effect(particle_smoke2,5*time,temp.X,nullvector);//smoke trail
		     }
            WAIT 1;
            }
        }

   //weak pain animation  
   IF(my.FRAMES_TO_PLAY == PAININGWEAK && my.HEALTH >= 1)
       {
        my.FRAME = FRM_pipkorg_PAINWEAK_START;
        WHILE(my.FRAME <= FRM_pipkorg_PAINWEAK_END && my.HEALTH >= 1)
           {
            my.FRAME +=FRM_pipkorg_PAINWEAK_ANIMSPEED*TIME;
            my.NEXT_FRAME = 0;
            WAIT 1;
            }
        IF(my.FRAMES_TO_PLAY != DYINGWEAK || my.FRAMES_TO_PLAY != DYINGSTRONG) { my.FRAMES_TO_PLAY = my.SKILL48;}
        my.PAIN_FRAMES_PLAYING = 0;
        }
     
     //strong pain animation  
     IF(my.FRAMES_TO_PLAY == PAININGSTRONG && my.HEALTH >= 1)
       {
        my.FRAME = FRM_pipkorg_PAINSTRONG_START;
        WHILE(my.FRAME <= FRM_pipkorg_PAINSTRONG_END && my.HEALTH >= 1)
           {
            my.FRAME +=FRM_pipkorg_PAINSTRONG_ANIMSPEED*TIME;
            my.NEXT_FRAME = 0;
            WAIT 1;
            }
        IF(my.FRAMES_TO_PLAY != DYINGWEAK || my.FRAMES_TO_PLAY != DYINGSTRONG) { my.FRAMES_TO_PLAY = my.SKILL48;}
        my.PAIN_FRAMES_PLAYING = 0;
        }

    WAIT 1;//for the big while loop
    }
}
//------------
 

//play pipkorg's death animation
//-----------------------------------------------------
function pipkorg_death_animation()
{
//weak die animation
IF(my.FRAMES_TO_PLAY == DYINGWEAK)
       {
        my.FRAME = FRM_pipkorg_DIEWEAK_START;
        WHILE(my.FRAME <= FRM_pipkorg_DIEWEAK_END)
           {
            my.FRAME +=FRM_pipkorg_DIEWEAK_ANIMSPEED*TIME;
            my.NEXT_FRAME = 0;
            WAIT 1;
           }
        SONAR ME,500;
        CREATE <blood.bmp>,TARGET,pipkorg_blood_pool;
        WAITT 300;
        REMOVE ME; 
        RETURN;
        }

//strong die animation
IF(my.FRAMES_TO_PLAY == DYINGSTRONG)
       {
        my.FRAME = FRM_pipkorg_DIESTRONG_START;
        WHILE(my.FRAME <= FRM_pipkorg_DIESTRONG_END)
           {
            my.FRAME +=FRM_pipkorg_DIESTRONG_ANIMSPEED*TIME;
            my.NEXT_FRAME = 0;
            WAIT 1;
           }
        SONAR ME,500;
        CREATE <blood.bmp>,TARGET,pipkorg_blood_pool;
        WAITT 300;
        REMOVE ME; 
        RETURN;
        }
}
//------------


//create blood pool below pipkorg
//------------------------------------------------------
function pipkorg_blood_pool()
{
vec_scale(my.SCALE_X,1);
my.LIGHTGREEN = 150;
my.LIGHTRANGE = 10;
my.LIGHT = ON;
my.FLARE = ON;
my.PASSABLE = ON;
my.ORIENTED = ON;
vec_to_angle(my.PAN,NORMAL);	// rotate to target normal
WHILE(my.SCALE_X <= 2)
   {
   my.SCALE_X += 0.008*TIME;
   my.SCALE_Y += 0.008*TIME;
   WAIT 1;
   }
WAITT 200;
REMOVE ME;
}
//------------


//pipkorg's bullet's event action
//------------------------------------------------------
function pipkorg_bullet_event()
{
IF(  EVENT_TYPE == EVENT_BLOCK
   ||EVENT_TYPE == EVENT_ENTITY
   ||EVENT_TYPE == EVENT_IMPACT)
      {
      pipkorg_bullet_nullify();  
      IF( you == player && godmode == 0) { 
                          IF(player_mode == HUMANMODE) { temp = 20;}
                          ELSE { temp = 15; } 
 			        IF(armour >= 1) { armour -= 10;armour = max(armour,0);temp = 8;}
                          player.HEALTH -= temp;
  				  player_damage_indicate();
                        }
      WHILE(red_circle_blinking) { WAIT 1;}
      REMOVE ME;
      RETURN;
      }
}
//-----------


//remove's pipkorg's bullet entity
//-----------------------------------------------------
function pipkorg_bullet_nullify()
{
my.EVENT = NULL;
my.ENABLE_BLOCK = OFF;
my.ENABLE_IMPACT = OFF;
my.ENABLE_ENTITY = OFF;
my.PASSABLE = ON;
my.PUSH = -100000;
my.INVISIBLE = ON;
my.LIGHTRANGE = 0;
}
//----------


//pipkorg's gun muzzle flash
//-----------------------------------------------------
function pipkorg_muzzle_flash()
{
//vec_scale(my.SCALE_X,0.6);
my.FACING = ON;
my.PASSABLE = ON;
my.NOFILTER = ON;
my.FLARE = ON;
my.LIGHTRED = 10;
my.LIGHTGREEN = 250;
my.LIGHTBLUE = 10;
my.LIGHTRANGE = 60;
my.LIGHT = ON;
my.BRIGHT = ON;
WAITT 2;
REMOVE ME;
}
//----------


//let pipkorg's bullet travel
//according to difficulty level
//------------------------------------------------------  
function pipkorg_bullet_action()
{
//vec_scale(my.SCALE_X,0.6);

//store creator
my.ENTITY1 = YOU;

//play bullet sound
play_entsound you,snd_pipkorg_bullet,600;

//store vertex coordinates
vec_set(my.SKILL1,temp.X);

//create muzzle flash at pipkorg's gun muzzle
//CREATE <gflash3.pcx>,temp,pipkorg_muzzle_flash;

YOU = my.ENTITY1;

//first increment the pipkorg's bullet hit counter
YOUR.BULLET_HIT_COUNTER += 1;
IF(YOUR.BULLET_HIT_COUNTER == 6)
    {
    YOUR.BULLET_HIT_COUNTER = 1;
    }

/*
//now set target according to difficulty level
//least difficult
IF(random(10) >= 5) { temp = -1;}
ELSE { temp = 1;}

IF(difficulty == 1)
  {
  my.SKILL4 = player.X + temp*(30 + random(20));
  my.SKILL5 = player.Y + temp*(30 + random(20));
  my.SKILL6 = player.Z + 5  + random(10);
  IF(YOUR.BULLET_HIT_COUNTER == 5) { vec_set(my.SKILL4,player.X);}
  }
IF(difficulty == 2)
  {
  my.SKILL4 = player.X + temp*(30 + random(20));
  my.SKILL5 = player.Y + temp*(30 + random(20));
  my.SKILL6 = player.Z + 5  + random(10);
  IF(YOUR.BULLET_HIT_COUNTER == 4 || YOUR.BULLET_HIT_COUNTER == 5 ) {vec_set(my.SKILL4,player.X);}
  }
IF(difficulty == 3)
  {
  my.SKILL4 = player.X + temp*(30 + random(20));
  my.SKILL5 = player.Y + temp*(30 + random(20));
  my.SKILL6 = player.Z + 5  + random(10);
  IF(YOUR.BULLET_HIT_COUNTER == 3 || YOUR.BULLET_HIT_COUNTER == 4 || YOUR.BULLET_HIT_COUNTER == 5  ) {vec_set(my.SKILL4,player.X);}
  }
*/

 vec_set(my.SKILL4,player.X);

 //now calculate its direction
 my.SKILL7 = my.SKILL4 - my.SKILL1;
 my.SKILL8 = my.SKILL5 - my.SKILL2;
 my.SKILL9 = my.SKILL6 - my.SKILL3;
 
 //now normalize bullet speed vector
 vec_normalize(my.SKILL7,pipkorg_BULLET_SPEED);

 //now rotate the bullet
 vec_to_angle(my.PAN,my.SKILL7);
 
 //apply special effects to bullet
 my.SCALE_X *= 0.7;
 my.SCALE_Y *= 0.2;
 my.SCALE_Z *= 0.2;
 my.LIGHTRED = 10;
 my.LIGHTGREEN = 250;
 my.LIGHTBLUE = 10;
 my.LIGHTRANGE = 50;
 my.LIGHT = ON;
 my.BRIGHT = ON;
 my.AMBIENT = 75;
 
 //let the bullet be able to collide
 my.ENABLE_BLOCK = ON;
 my.ENABLE_ENTITY = ON;
 my.ENABLE_IMPACT = ON;

 //set event action
 my.EVENT = pipkorg_bullet_event;

 //lifecounter
 my.SKILl10 = 0; 

 //now move the bullet
 WHILE(my.SKILL10 != 200)
  {
  WAIT 1;
  pipkorg_bullet_drop();
  my.SKILl10 += 1;
  vec_set(pipkorg_bullet_vector,my.SKILL7);  
  vec_scale(pipkorg_bullet_vector,TIME);
  ent_move(nullskill,pipkorg_bullet_vector);
  }

//remove bullet
REMOVE ME;
}
//-----------
 

//--------------------------------------------
function pipkorg_blood_fade()
{
my.alpha -= time * 2;  // stay with framerate
if(my.alpha < 0) { my.lifespan = 0;}
}
//-----------

 
//--------------------------------------------
function pipkorg_vec_blood(&vec)
{
vec[0] = random(8) - 4;
vec[1] = random(8) - 4;
vec[2] = random(20) - 13;
}
//----------

//--------------------------------------------
function pipkorg_vec_bullet(&vec)
{
vec[0] = random(1) - 2;
vec[1] = random(1) - 2;
vec[2] = random(1) - 2;
}
//----------

//--------------------------------------------
function pipkorg_particle_blood()
{
pipkorg_vec_blood(temp);
vec_set(my.vel_x,temp); //set the velocity
my.lifespan = 30;
my.flare = on;	//flare transparency
my.move = on;	//move according to vel_x, vel_y, and vel_z
my.bmap = bmp_pipkorg_blood;
//my.beam = on;
//my.streak = on;
my.gravity = 2;
my.alpha = 30;
my.size = 1;
my.function = pipkorg_blood_fade;	//fade out near end of life
}
//-----------

//--------------------------------------------
function pipkorg_particle_bullet()
{
pipkorg_vec_bullet(temp);
vec_set(my.vel_x,temp); //set the velocity
my.lifespan = 60;
my.flare = on;	//flare transparency
my.move = on;	//move according to vel_x, vel_y, and vel_z
my.bmap = bmp_pipkorg_blood;
//my.beam = on;
//my.streak = on;
my.gravity = 2;
my.alpha = 50;
my.size = 2;
my.function = pipkorg_blood_fade;	//fade out near end of life
}
//-----------

//-------------------------------------------
function pipkorg_blood_spurt()
{
my.skill47 = INT(random(800));	
ent_vertex(temp,my.skill47);
effect(pipkorg_particle_blood,2+5*time,temp.X,nullvector);
}
//----------

//-------------------------------------------
function pipkorg_blood_drop()
{
effect(pipkorg_particle_blood,1+time,my.X,nullvector);
}
//----------

//-------------------------------------------
function pipkorg_bullet_drop()
{
effect(pipkorg_particle_bullet,10+time,my.X,nullvector);
}
//----------

//-----------FUTURE WORK--------------------------------
//trigger based pipkorgs
ACTION pipkorg
{
my.PASSABLE = ON;
}







